Package: perpetual
Type: Package
Title: PerpetualBooster
Version: 3.0.0
Authors@R: c(
    person("Mutlu", "Simsek", email = "msimsek@perpetual-ml.com", role = c("aut", "cre")),
    person("Serkan", "Korkmaz", email = "serkor1@duck.com", role = "aut"),
    person("Pieter", "Pel", email = "pelpieter@gmail.com", role = "aut")
  )
Description: A self-generalizing gradient boosting machine that doesn't need hyperparameter optimization.
URL: https://perpetual-ml.github.io/perpetual/r/
License: Apache License (== 2.0)
Suggests: 
    jsonlite,
    testthat (>= 3.0.0)
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: true
Biarch: true
SystemRequirements: Cargo (Rust's package manager), rustc
RoxygenNote: 7.3.3

<p align="center">
  <img  height="120" src="https://github.com/perpetual-ml/perpetual/raw/main/resources/perp_logo.png">
</p>

<div align="center">

[![Python Versions](https://img.shields.io/pypi/pyversions/perpetual.svg?logo=python&logoColor=white)](https://pypi.org/project/perpetual)
[![PyPI Version](https://img.shields.io/pypi/v/perpetual.svg?logo=pypi&logoColor=white)](https://pypi.org/project/perpetual)
[![Crates.io Version](https://img.shields.io/crates/v/perpetual?logo=rust&logoColor=white)](https://crates.io/crates/perpetual)
[![Static Badge](https://img.shields.io/badge/join-discord-blue?logo=discord)](https://discord.gg/AyUK7rr6wy)
![PyPI - Downloads](https://img.shields.io/pypi/dm/perpetual)


</div>

# Perpetual

PerpetualBooster is a gradient boosting machine (GBM) algorithm that doesn't need hyperparameter optimization unlike other GBMs. Similar to AutoML libraries, it has a `budget` parameter. Increasing the `budget` parameter increases the predictive power of the algorithm and gives better results on unseen data. Start with a small budget (e.g. 0.5) and increase it (e.g. 1.0) once you are confident with your features. If you don't see any improvement with further increasing the `budget`, it means that you are already extracting the most predictive power out of your data.

## Usage

You can use the algorithm like in the example below. Check examples folders for both Rust and Python.

```python
from perpetual import PerpetualBooster

model = PerpetualBooster(objective="SquaredLoss", budget=0.5)
model.fit(X, y)
```

## Documentation

Documentation for the Python API can be found [here](https://perpetual-ml.github.io/perpetual) and for the Rust API [here](https://docs.rs/perpetual/latest/perpetual/).


## Benchmark

### PerpetualBooster vs. Optuna + LightGBM

Hyperparameter optimization usually takes 100 iterations with plain GBM algorithms. PerpetualBooster achieves the same accuracy in a single run. Thus, it achieves up to 100x speed-up at the same accuracy with different `budget` levels and with different datasets.

The following table summarizes the results for the [California Housing](https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_california_housing.html) dataset (regression):

| Perpetual budget | LightGBM n_estimators | Perpetual mse | LightGBM mse | Speed-up wall time | Speed-up cpu time |
| ---------------- | --------------------- | ------------- | ------------ | ------------------ | ----------------- |
| 1.0              | 100                   | 0.192         | 0.192        | 54x                | 56x               |
| 1.5              | 300                   | 0.188         | 0.188        | 59x                | 58x               |
| 2.1              | 1000                  | 0.185         | 0.186        | 42x                | 41x               |

The following table summarizes the results for the [Cover Types](https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_covtype.html) dataset (classification):

| Perpetual budget | LightGBM n_estimators | Perpetual log loss | LightGBM log loss | Speed-up wall time | Speed-up cpu time |
| ---------------- | --------------------- | ------------------ | ----------------- | ------------------ | ----------------- |
| 0.9              | 100                   | 0.091              | 0.084             | 72x                | 78x               |

The results can be reproduced using the scripts in the [examples](./python-package/examples) folder.

### PerpetualBooster vs. AutoGluon

PerpetualBooster is a GBM but behaves like AutoML so it is benchmarked also against AutoGluon (v1.2, best quality preset), the current leader in [AutoML benchmark](https://automlbenchmark.streamlit.app/cd_diagram). Top 10 datasets with the most number of rows are selected from [OpenML datasets](https://www.openml.org/) for both regression and classification tasks. 

The results are summarized in the following table for regression tasks:

| OpenML Task | Perpetual Training Duration | Perpetual Inference Duration | Perpetual RMSE | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon RMSE |
| -------------------------------------------------------- | ----- | ----- | ------------------- | -------- | ------ | ------------------ |
| [Airlines_DepDelay_10M](https://www.openml.org/t/359929) | 518   | 11.3  | 29.0                | 520      | 30.9   | <ins> 28.8 </ins>  |
| [bates_regr_100](https://www.openml.org/t/361940)        | 3421  | 15.1  | <ins> 1.084 </ins>  | OOM      | OOM    | OOM                |
| [BNG(libras_move)](https://www.openml.org/t/7327)        | 1956  | 4.2   | <ins> 2.51 </ins>   | 1922     | 97.6   | 2.53               |
| [BNG(satellite_image)](https://www.openml.org/t/7326)    | 334   | 1.6   | 0.731               | 337      | 10.0   | <ins> 0.721 </ins> |
| [COMET_MC](https://www.openml.org/t/14949)               | 44    | 1.0   | <ins> 0.0615 </ins> | 47       | 5.0    | 0.0662             |
| [friedman1](https://www.openml.org/t/361939)             | 275   | 4.2   | <ins> 1.047 </ins>  | 278      | 5.1    | 1.487              |
| [poker](https://www.openml.org/t/10102)                  | 38    | 0.6   | <ins> 0.256 </ins>  | 41       | 1.2    | 0.722              |
| [subset_higgs](https://www.openml.org/t/361955)          | 868   | 10.6  | <ins> 0.420 </ins>  | 870      | 24.5   | 0.421              |
| [BNG(autoHorse)](https://www.openml.org/t/7319)          | 107   | 1.1   | <ins> 19.0 </ins>   | 107      | 3.2    | 20.5               |
| [BNG(pbc)](https://www.openml.org/t/7318)                | 48    | 0.6   | <ins> 836.5 </ins>  | 51       | 0.2    | 957.1              |
| average                                                  | 465   | 3.9   | -                   | 464      | 19.7   | -                  |

PerpetualBooster outperformed AutoGluon on 8 out of 10 regression tasks, training equally fast and inferring 5.1x faster. 

The results are summarized in the following table for classification tasks:

| OpenML Task | Perpetual Training Duration | Perpetual Inference Duration | Perpetual AUC | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon AUC |
| -------------------------------------------------------- | ------- | ------ | ------------------- | -------- | ------ | ------------------ |
| [BNG(spambase)](https://www.openml.org/t/146163)         | 70.1    | 2.1   | <ins> 0.671 </ins> | 73.1     | 3.7    | 0.669              |
| [BNG(trains)](https://www.openml.org/t/208)              | 89.5    | 1.7   | <ins> 0.996 </ins> | 106.4    | 2.4    | 0.994              |
| [breast](https://www.openml.org/t/361942)                | 13699.3 | 97.7  | <ins> 0.991 </ins> | 13330.7  | 79.7   | 0.949              |
| [Click_prediction_small](https://www.openml.org/t/7291)  | 89.1    | 1.0   | <ins> 0.749 </ins> | 101.0    | 2.8    | 0.703              |
| [colon](https://www.openml.org/t/361938)                 | 12435.2 | 126.7 | <ins> 0.997 </ins> | 12356.2  | 152.3  | 0.997              |
| [Higgs](https://www.openml.org/t/362113)                 | 3485.3  | 40.9  | <ins> 0.843 </ins> | 3501.4   | 67.9   | 0.816              |
| [SEA(50000)](https://www.openml.org/t/230)               | 21.9    | 0.2   | <ins> 0.936 </ins> | 25.6     | 0.5    | 0.935              |
| [sf-police-incidents](https://www.openml.org/t/359994)   | 85.8    | 1.5   | <ins> 0.687 </ins> | 99.4     | 2.8    | 0.659              |
| [bates_classif_100](https://www.openml.org/t/361941)     | 11152.8 | 50.0  | <ins> 0.864 </ins> | OOM      | OOM    | OOM                |
| [prostate](https://www.openml.org/t/361945)              | 13699.9 | 79.8  | <ins> 0.987 </ins> | OOM      | OOM    | OOM                |
| average                                                  | 3747.0  | 34.0  | -                  | 3699.2   | 39.0   | -                  |

PerpetualBooster outperformed AutoGluon on 10 out of 10 classification tasks, training equally fast and inferring 1.1x faster. 

PerpetualBooster demonstrates greater robustness compared to AutoGluon, successfully training on all 20 tasks, whereas AutoGluon encountered out-of-memory errors on 3 of those tasks.

The results can be reproduced using the automlbenchmark fork [here](https://github.com/deadsoul44/automlbenchmark).



## Installation

The package can be installed directly from [pypi](https://pypi.org/project/perpetual):

```shell
pip install perpetual
```

Using [conda-forge](https://anaconda.org/conda-forge/perpetual):

```shell
conda install conda-forge::perpetual
```

To use in a Rust project and to get the package from [crates.io](https://crates.io/crates/perpetual):

```shell
cargo add perpetual
```

## Contribution

Contributions are welcome. Check CONTRIBUTING.md for the guideline.

## Paper

PerpetualBooster prevents overfitting with a generalization algorithm. The paper is work-in-progress to explain how the algorithm works. Check our [blog post](https://perpetual-ml.com/blog/how-perpetual-works) for a high level introduction to the algorithm.

## Perpetual ML Suite

Perpetual ML Suite is a data warehouse-native, batteries included ML platform where you can get the best predictive power in the shortest amount of time, easily track and compare all your model experiments, instantly deploy models for batch or real-time inference, effortlessly monitor your metrics, data drift, and concept drift, continuously learn from real-time data from a single, intuitive web interface that integrates directly with your existing data warehouse. It is [available on Snowflake marketplace](https://app.snowflake.com/marketplace/listing/GZSYZX0EMJ/perpetual-ml-perpetual-ml-suite), under development for Databricks with future plans to expand to other data warehousing solutions.

<!-- markdownlint-disable MD033 -->
# Perpetual

<p align="center">
  <img  height="120" src="https://github.com/perpetual-ml/perpetual/raw/main/resources/perp_logo.png" alt="Perpetual Logo">
</p>

<div align="center">

<a href="https://pypi.org/project/perpetual" target="_blank"><img src="https://img.shields.io/pypi/pyversions/perpetual.svg?logo=python&logoColor=white" alt="Python Versions"></a>
<a href="https://pypi.org/project/perpetual" target="_blank"><img src="https://img.shields.io/pypi/v/perpetual.svg?logo=pypi&logoColor=white" alt="PyPI Version"></a>
<a href="https://anaconda.org/conda-forge/perpetual" target="_blank"><img src="https://img.shields.io/conda/v/conda-forge/perpetual?label=conda-forge&logo=anaconda&logoColor=white" alt="Conda Version"></a>
<a href="https://crates.io/crates/perpetual" target="_blank"><img src="https://img.shields.io/crates/v/perpetual?logo=rust&logoColor=white" alt="Crates.io Version"></a>
<a href="https://perpetual-ml.r-universe.dev/perpetual" target="_blank"><img src="https://img.shields.io/badge/dynamic/json?url=https://perpetual-ml.r-universe.dev/api/packages/perpetual&query=$.Version&label=r-universe&logo=R&logoColor=white&color=brightgreen" alt="R-Universe status"></a>
<a href="https://discord.gg/AyUK7rr6wy" target="_blank"><img src="https://img.shields.io/badge/join-discord-blue?logo=discord" alt="Static Badge"></a>
<a href="https://pypi.org/project/perpetual" target="_blank"><img src="https://img.shields.io/pypi/dm/perpetual?logo=pypi" alt="PyPI - Downloads"></a>
<a href="https://github.com/pre-commit/pre-commit" target="_blank"><img src="https://img.shields.io/badge/pre--commit-enabled-brightgreen?logo=pre-commit&logoColor=white" alt="pre-commit"></a>
<a href="https://github.com/astral-sh/ruff" target="_blank"><img src="https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/astral-sh/ruff/main/assets/badge/v2.json" alt="Ruff"></a>
<a href="https://app.codecov.io/gh/perpetual-ml/perpetual" target="_blank"><img src="https://img.shields.io/codecov/c/github/perpetual-ml/perpetual?flag=python&label=codecov%20python" alt="Python Coverage"></a>
<a href="https://app.codecov.io/gh/perpetual-ml/perpetual" target="_blank"><img src="https://img.shields.io/codecov/c/github/perpetual-ml/perpetual?flag=rust&label=codecov%20rust" alt="Rust Coverage"></a>
<a href="https://app.codecov.io/gh/perpetual-ml/perpetual" target="_blank"><img src="https://img.shields.io/codecov/c/github/perpetual-ml/perpetual?flag=r&label=codecov%20r" alt="R Coverage"></a>
<a href="./LICENSE" target="_blank"><img src="https://img.shields.io/github/license/perpetual-ml/perpetual" alt="License"></a>

</div>

PerpetualBooster is a gradient boosting machine (GBM) that doesn't need hyperparameter optimization unlike other GBMs. Similar to AutoML libraries, it has a `budget` parameter. Increasing the `budget` parameter increases the predictive power of the algorithm and gives better results on unseen data. Start with a small budget (e.g. 0.5) and increase it (e.g. 1.0) once you are confident with your features. If you don't see any improvement with further increasing the `budget`, it means that you are already extracting the most predictive power out of your data.

## Features

- **Hyperparameter-Free Learning:** Achieves optimal accuracy in a single run via a simple `budget` parameter, eliminating the need for time-consuming hyperparameter optimization.
- **High-Performance Rust Core:** Blazing-fast training and inference with a native Rust core, zero-copy support for Polars/Arrow data, and robust Python & R bindings.
- **Comprehensive Objectives:** Fully supports Classification (Binary & Multi-class), Regression, and Ranking tasks.
- **Advanced Tree Features:** Natively handles categorical variables, learnable missing value splits, monotonic constraints, and feature interaction constraints.
- **Built-in Causal ML:** Out-of-the-box support for causal machine learning to estimate treatment effects.
- **Robust Drift Monitoring:** Built-in capabilities to monitor both data drift and concept drift without requiring ground truth labels or model retraining.
- **Continual Learning:** Built-in continual learning capabilities that significantly reduce computational time from O(n²) to O(n).
- **Native Calibration:** Built-in calibration features to predict fully calibrated distributions (marginal coverage) and conditional coverage without retraining.
- **Explainability:** Easily interpret model decisions using built-in feature importance, partial dependence plots, and Shapley (SHAP) values.
- **Production Ready & Interoperable:** Ready for production applications; seamlessly export models to industry-standard XGBoost or ONNX formats for straightforward deployment.

## Supported Languages

Perpetual is built in Rust and provides high-performance bindings for Python and R.

<!-- markdownlint-disable MD060 -->
| Language   | Installation                                                            | Documentation                                                                       | Source                                                        | Package                                                                                                                                                             |
| :--------- | :---------------------------------------------------------------------- | :---------------------------------------------------------------------------------- | :------------------------------------------------------------ | :---------------------------------------------------------------------------------------------------------------------------------- |
| **Python** | `pip install perpetual`<br><br>`conda install -c conda-forge perpetual` | <a href="https://perpetual-ml.github.io/perpetual" target="_blank">Python API</a>   | <a href="./package-python" target="_blank">`package-python`</a> | <a href="https://pypi.org/project/perpetual" target="_blank">PyPI</a><br><br><a href="https://anaconda.org/conda-forge/perpetual" target="_blank">Conda Forge</a>   |
| **Rust**   | `cargo add perpetual`                                                   | <a href="https://docs.rs/perpetual" target="_blank">docs.rs</a>                     | <a href="./src" target="_blank">`src`</a>                     | <a href="https://crates.io/crates/perpetual" target="_blank">crates.io</a>                                                          |
| **R**      | `install.packages("perpetual")`                                         | <a href="https://perpetual-ml.github.io/perpetual/r" target="_blank">pkgdown Site</a> | <a href="./package-r" target="_blank">`package-r`</a>         | <a href="https://perpetual-ml.r-universe.dev/perpetual" target="_blank">R-universe</a>                                              |

### Optional Dependencies

- `pandas`: Enables support for training directly on Pandas DataFrames.
- `polars`: Enables zero-copy training support for Polars DataFrames.
- `scikit-learn`: Provides a scikit-learn compatible wrapper interface.
- `xgboost`: Enables saving and loading models in XGBoost format for interoperability.
- `onnxruntime`: Enables exporting and loading models in ONNX standard format.

## Usage

You can use the algorithm like in the example below. Check examples folders for both Rust and Python.

```python
from perpetual import PerpetualBooster

model = PerpetualBooster(objective="SquaredLoss", budget=0.5)
model.fit(X, y)
```

## Benchmark

### PerpetualBooster vs. Optuna + LightGBM

Hyperparameter optimization usually takes 100 iterations with plain GBM algorithms. PerpetualBooster achieves the same accuracy in a single run. Thus, it achieves up to 100x speed-up at the same accuracy with different `budget` levels and with different datasets.

The following table summarizes the results for the <a href="https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_california_housing.html" target="_blank">California Housing</a> dataset (regression):

| Perpetual budget | LightGBM n_estimators | Perpetual mse | LightGBM mse | Speed-up wall time | Speed-up cpu time |
| :--------------- | :-------------------- | :------------ | :----------- | :----------------- | :---------------- |
| 0.76             | 50                    | 0.201         | 0.201        | 72x                | 326x              |
| 0.85             | 100                   | 0.196         | 0.196        | 113x               | 613x              |
| 1.15             | 200                   | 0.190         | 0.190        | 405x               | 1985x             |

The following table summarizes the results for the <a href="https://www.openml.org/search?type=data&status=active&id=46951" target="_blank">Pumpkin Seeds</a> dataset (classification):

| Perpetual budget | LightGBM n_estimators | Perpetual auc      | LightGBM auc      | Speed-up wall time | Speed-up cpu time |
| :--------------- | :-------------------- | :----------------- | :---------------- | :----------------- | :---------------- |
| 1.0              | 100                   | 0.944              | 0.945             | 91x                | 184x              |

The results can be reproduced using the scripts in the <a href="./package-python/examples" target="_blank">examples</a> folder.

### PerpetualBooster vs. AutoGluon

PerpetualBooster is a GBM but behaves like AutoML so it is benchmarked also against AutoGluon (v1.2, best quality preset), the current leader in <a href="https://automlbenchmark.streamlit.app/cd_diagram" target="_blank">AutoML benchmark</a>. Top 10 datasets with the most number of rows are selected from <a href="https://www.openml.org/" target="_blank">OpenML datasets</a> for both regression and classification tasks.

The results are summarized in the following table for regression tasks:

| OpenML Task                                                                         | Perpetual Training Duration | Perpetual Inference Duration | Perpetual RMSE      | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon RMSE     |
| :---------------------------------------------------------------------------------- | :-------------------------- | :--------------------------- | :------------------ | :-------------------------- | :--------------------------- | :----------------- |
| <a href="https://www.openml.org/t/359929" target="_blank">Airlines_DepDelay_10M</a> | 518                         | 11.3                         | 29.0                | 520                         | 30.9                         | <ins> 28.8 </ins>  |
| <a href="https://www.openml.org/t/361940" target="_blank">bates_regr_100</a>        | 3421                        | 15.1                         | <ins> 1.084 </ins>  | OOM                         | OOM                          | OOM                |
| <a href="https://www.openml.org/t/7327" target="_blank">BNG(libras_move)</a>        | 1956                        | 4.2                          | <ins> 2.51 </ins>   | 1922                        | 97.6                         | 2.53               |
| <a href="https://www.openml.org/t/7326" target="_blank">BNG(satellite_image)</a>    | 334                         | 1.6                          | 0.731               | 337                         | 10.0                         | <ins> 0.721 </ins> |
| <a href="https://www.openml.org/t/14949" target="_blank">COMET_MC</a>               | 44                          | 1.0                          | <ins> 0.0615 </ins> | 47                          | 5.0                          | 0.0662             |
| <a href="https://www.openml.org/t/361939" target="_blank">friedman1</a>             | 275                         | 4.2                          | <ins> 1.047 </ins>  | 278                         | 5.1                          | 1.487              |
| <a href="https://www.openml.org/t/10102" target="_blank">poker</a>                  | 38                          | 0.6                          | <ins> 0.256 </ins>  | 41                          | 1.2                          | 0.722              |
| <a href="https://www.openml.org/t/361955" target="_blank">subset_higgs</a>          | 868                         | 10.6                         | <ins> 0.420 </ins>  | 870                         | 24.5                         | 0.421              |
| <a href="https://www.openml.org/t/7319" target="_blank">BNG(autoHorse)</a>          | 107                         | 1.1                          | <ins> 19.0 </ins>   | 107                         | 3.2                          | 20.5               |
| <a href="https://www.openml.org/t/7318" target="_blank">BNG(pbc)</a>                | 48                          | 0.6                          | <ins> 836.5 </ins>  | 51                          | 0.2                          | 957.1              |
| average                                                                             | 465                         | 3.9                          | -                   | 464                         | 19.7                         | -                  |

PerpetualBooster outperformed AutoGluon on 8 out of 10 regression tasks, training equally fast and inferring 5.1x faster.

The results are summarized in the following table for classification tasks:

| OpenML Task                                                                        | Perpetual Training Duration | Perpetual Inference Duration | Perpetual AUC      | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon AUC |
| :--------------------------------------------------------------------------------- | :-------------------------- | :--------------------------- | :----------------- | :-------------------------- | :--------------------------- | :------------ |
| <a href="https://www.openml.org/t/146163" target="_blank">BNG(spambase)</a>        | 70.1                        | 2.1                          | <ins> 0.671 </ins> | 73.1                        | 3.7                          | 0.669         |
| <a href="https://www.openml.org/t/208" target="_blank">BNG(trains)</a>             | 89.5                        | 1.7                          | <ins> 0.996 </ins> | 106.4                       | 2.4                          | 0.994         |
| <a href="https://www.openml.org/t/361942" target="_blank">breast</a>               | 13699.3                     | 97.7                         | <ins> 0.991 </ins> | 13330.7                     | 79.7                         | 0.949         |
| <a href="https://www.openml.org/t/7291" target="_blank">Click_prediction_small</a> | 89.1                        | 1.0                          | <ins> 0.749 </ins> | 101.0                       | 2.8                          | 0.703         |
| <a href="https://www.openml.org/t/361938" target="_blank">colon</a>                | 12435.2                     | 126.7                        | <ins> 0.997 </ins> | 12356.2                     | 152.3                        | 0.997         |
| <a href="https://www.openml.org/t/362113" target="_blank">Higgs</a>                | 3485.3                      | 40.9                         | <ins> 0.843 </ins> | 3501.4                      | 67.9                         | 0.816         |
| <a href="https://www.openml.org/t/230" target="_blank">SEA(50000)</a>              | 21.9                        | 0.2                          | <ins> 0.936 </ins> | 25.6                        | 0.5                          | 0.935         |
| <a href="https://www.openml.org/t/359994" target="_blank">sf-police-incidents</a>  | 85.8                        | 1.5                          | <ins> 0.687 </ins> | 99.4                        | 2.8                          | 0.659         |
| <a href="https://www.openml.org/t/361941" target="_blank">bates_classif_100</a>    | 11152.8                     | 50.0                         | <ins> 0.864 </ins> | OOM                         | OOM                          | OOM           |
| <a href="https://www.openml.org/t/361945" target="_blank">prostate</a>             | 13699.9                     | 79.8                         | <ins> 0.987 </ins> | OOM                         | OOM                          | OOM           |
| average                                                                            | 3747.0                      | 34.0                         | -                  | 3699.2                      | 39.0                         | -             |

PerpetualBooster outperformed AutoGluon on 10 out of 10 classification tasks, training equally fast and inferring 1.1x faster.

PerpetualBooster demonstrates greater robustness compared to AutoGluon, successfully training on all 20 tasks, whereas AutoGluon encountered out-of-memory errors on 3 of those tasks.

The results can be reproduced using the <a href="https://github.com/deadsoul44/automlbenchmark" target="_blank">automlbenchmark fork</a>.

## Contribution

Contributions are welcome. Check <a href="./CONTRIBUTING.md" target="_blank">CONTRIBUTING.md</a> for the guideline.

## Paper

PerpetualBooster prevents overfitting with a generalization algorithm. The paper is work-in-progress to explain how the algorithm works. Check our <a href="https://perpetual-ml.com/blog/how-perpetual-works" target="_blank">blog post</a> for a high level introduction to the algorithm.

## Perpetual ML Suite

The **Perpetual ML Suite** is a comprehensive, batteries-included ML platform designed to deliver maximum predictive power with minimal effort. It allows you to track experiments, monitor metrics, and manage model drift through an intuitive interface.

For a fully managed, **serverless ML experience**, visit <a href="https://app.perpetual-ml.com" target="_blank">app.perpetual-ml.com</a>.

- **Serverless Marimo Notebooks**: Run interactive, reactive notebooks without managing any infrastructure.
- **Serverless ML Endpoints**: One-click deployment of models as production-ready endpoints for real-time inference.

Perpetual is also designed to live where your data lives. It is available as a native application on the <a href="https://app.snowflake.com/marketplace/listing/GZSYZX0EMJ/perpetual-ml-perpetual-ml-suite" target="_blank">Snowflake Marketplace</a>, with support for Databricks and other major data warehouses coming soon.

<p align="center">
  <img  height="120" src="https://github.com/perpetual-ml/perpetual/raw/main/resources/perp_logo.png">
</p>

<div align="center">

[![Python Versions](https://img.shields.io/pypi/pyversions/perpetual.svg?logo=python&logoColor=white)](https://pypi.org/project/perpetual)
[![PyPI Version](https://img.shields.io/pypi/v/perpetual.svg?logo=pypi&logoColor=white)](https://pypi.org/project/perpetual)
[![Crates.io Version](https://img.shields.io/crates/v/perpetual?logo=rust&logoColor=white)](https://crates.io/crates/perpetual)
[![Static Badge](https://img.shields.io/badge/join-discord-blue?logo=discord)](https://discord.gg/AyUK7rr6wy)

</div>

# Perpetual

PerpetualBooster is a gradient boosting machine (GBM) algorithm which doesn't need hyperparameter optimization unlike other GBM algorithms. Similar to AutoML libraries, it has a `budget` parameter. Increasing the `budget` parameter increases the predictive power of the algorithm and gives better results on unseen data. Start with a small budget (e.g. 1.0) and increase it (e.g. 2.0) once you are confident with your features. If you don't see any improvement with further increasing the `budget`, it means that you are already extracting the most predictive power out of your data.

## Benchmark

Hyperparameter optimization usually takes 100 iterations with plain GBM algorithms. PerpetualBooster achieves the same accuracy in a single run. Thus, it achieves up to 100x speed-up at the same accuracy with different `budget` levels and with different datasets.

The following table summarizes the results for the [California Housing](https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_california_housing.html) dataset (regression):

| Perpetual budget | LightGBM n_estimators | Perpetual mse | LightGBM mse | Speed-up wall time | Speed-up cpu time |
| ---------------- | --------------------- | ------------- | ------------ | ------------------ | ----------------- |
| 1.0              | 100                   | 0.192         | 0.192        | 54x                | 56x               |
| 1.5              | 300                   | 0.188         | 0.188        | 59x                | 58x               |
| 2.1              | 1000                  | 0.185         | 0.186        | 42x                | 41x               |

The following table summarizes the results for the [Cover Types](https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_covtype.html) dataset (classification):

| Perpetual budget | LightGBM n_estimators | Perpetual log loss | LightGBM log loss | Speed-up wall time | Speed-up cpu time |
| ---------------- | --------------------- | ------------------ | ----------------- | ------------------ | ----------------- |
| 0.9              | 100                   | 0.091              | 0.084             | 72x                | 78x               |

You can reproduce the results using the scripts in the [examples](./python-package/examples) folder.

## Usage

You can use the algorithm like in the example below. Check examples folders for both Rust and Python.

```python
from perpetual import PerpetualBooster

model = PerpetualBooster(objective="SquaredLoss")
model.fit(X, y, budget=1.0)
```

## Documentation

Documentation for the Python API can be found [here](https://perpetual-ml.github.io/perpetual) and for the Rust API [here](https://docs.rs/perpetual/latest/perpetual/).

## Installation

The package can be installed directly from [pypi](https://pypi.org/project/perpetual).

```shell
pip install perpetual
```

Using [conda-forge](https://anaconda.org/conda-forge/perpetual):

```shell
conda install conda-forge::perpetual
```

To use in a Rust project, add the following to your Cargo.toml file to get the package from [crates.io](https://crates.io/crates/perpetual).

```toml
perpetual = "0.7.0"
```

## Contribution

Contributions are welcome. Check CONTRIBUTING.md for the guideline.

## Paper

PerpetualBooster prevents overfitting with a generalization algorithm. The paper is work-in-progress to explain how the algorithm works. Check our [blog post](https://perpetual-ml.com/blog/how-perpetual-works) for a high level introduction to the algorithm.

<!-- markdownlint-disable MD033 -->
# Perpetual

<p align="center">
  <img  height="120" src="https://github.com/perpetual-ml/perpetual/raw/main/resources/perp_logo.png" alt="Perpetual Logo">
</p>

<div align="center">

<a href="https://pypi.org/project/perpetual" target="_blank"><img src="https://img.shields.io/pypi/pyversions/perpetual.svg?logo=python&logoColor=white" alt="Python Versions"></a>
<a href="https://pypi.org/project/perpetual" target="_blank"><img src="https://img.shields.io/pypi/v/perpetual.svg?logo=pypi&logoColor=white" alt="PyPI Version"></a>
<a href="https://crates.io/crates/perpetual" target="_blank"><img src="https://img.shields.io/crates/v/perpetual?logo=rust&logoColor=white" alt="Crates.io Version"></a>
<a href="https://perpetual-ml.r-universe.dev/perpetual" target="_blank"><img src="https://img.shields.io/badge/dynamic/json?url=https://perpetual-ml.r-universe.dev/api/packages/perpetual&query=$.Version&label=r-universe&logo=R&logoColor=white&color=brightgreen" alt="R-Universe status"></a>
<a href="https://discord.gg/AyUK7rr6wy" target="_blank"><img src="https://img.shields.io/badge/join-discord-blue?logo=discord" alt="Static Badge"></a>
![PyPI - Downloads](https://img.shields.io/pypi/dm/perpetual)

</div>

PerpetualBooster is a gradient boosting machine (GBM) algorithm that doesn't need hyperparameter optimization unlike other GBMs. Similar to AutoML libraries, it has a `budget` parameter. Increasing the `budget` parameter increases the predictive power of the algorithm and gives better results on unseen data. Start with a small budget (e.g. 0.5) and increase it (e.g. 1.0) once you are confident with your features. If you don't see any improvement with further increasing the `budget`, it means that you are already extracting the most predictive power out of your data.

## Supported Languages

Perpetual is built in Rust and provides high-performance bindings for Python and R.

| Language   | Installation                    | Documentation                                                                         | Repository                                                      |
| :--------- | :------------------------------ | :------------------------------------------------------------------------------------ | :-------------------------------------------------------------- |
| **Python** | `pip install perpetual`         | <a href="https://perpetual-ml.github.io/perpetual" target="_blank">Python API</a>     | <a href="./package-python" target="_blank">`package-python`</a> |
| **Rust**   | `cargo add perpetual`           | <a href="https://docs.rs/perpetual" target="_blank">docs.rs</a>                       | <a href="./src" target="_blank">`src`</a>                       |
| **R**      | `install.packages("perpetual")` | <a href="https://perpetual-ml.github.io/perpetual/r" target="_blank">pkgdown Site</a> | <a href="./package-r" target="_blank">`package-r`</a>           |

## Usage

You can use the algorithm like in the example below. Check examples folders for both Rust and Python.

```python
from perpetual import PerpetualBooster

model = PerpetualBooster(objective="SquaredLoss", budget=0.5)
model.fit(X, y)
```

## Documentation

Comprehensive documentation for all supported languages is available:

- **Python**: <a href="https://perpetual-ml.github.io/perpetual" target="_blank">API Reference & Guides</a>
- **Rust**: <a href="https://docs.rs/perpetual" target="_blank">docs.rs/perpetual</a>
- **R**: <a href="https://perpetual-ml.github.io/perpetual/r" target="_blank">pkgdown Documentation</a>

## Benchmark

### PerpetualBooster vs. Optuna + LightGBM

Hyperparameter optimization usually takes 100 iterations with plain GBM algorithms. PerpetualBooster achieves the same accuracy in a single run. Thus, it achieves up to 100x speed-up at the same accuracy with different `budget` levels and with different datasets.

The following table summarizes the results for the <a href="https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_california_housing.html" target="_blank">California Housing</a> dataset (regression):

| Perpetual budget | LightGBM n_estimators | Perpetual mse | LightGBM mse | Speed-up wall time | Speed-up cpu time |
| :--------------- | :-------------------- | :------------ | :----------- | :----------------- | :---------------- |
| 1.0              | 100                   | 0.192         | 0.192        | 54x                | 56x               |
| 1.5              | 300                   | 0.188         | 0.188        | 59x                | 58x               |
| 2.1              | 1000                  | 0.185         | 0.186        | 42x                | 41x               |

The following table summarizes the results for the <a href="https://scikit-learn.org/stable/modules/generated/sklearn.datasets.fetch_covtype.html" target="_blank">Cover Types</a> dataset (classification):

| Perpetual budget | LightGBM n_estimators | Perpetual log loss | LightGBM log loss | Speed-up wall time | Speed-up cpu time |
| :--------------- | :-------------------- | :----------------- | :---------------- | :----------------- | :---------------- |
| 0.9              | 100                   | 0.091              | 0.084             | 72x                | 78x               |

The results can be reproduced using the scripts in the <a href="./package-python/examples" target="_blank">examples</a> folder.

### PerpetualBooster vs. AutoGluon

PerpetualBooster is a GBM but behaves like AutoML so it is benchmarked also against AutoGluon (v1.2, best quality preset), the current leader in <a href="https://automlbenchmark.streamlit.app/cd_diagram" target="_blank">AutoML benchmark</a>. Top 10 datasets with the most number of rows are selected from <a href="https://www.openml.org/" target="_blank">OpenML datasets</a> for both regression and classification tasks.

The results are summarized in the following table for regression tasks:

| OpenML Task                                                                         | Perpetual Training Duration | Perpetual Inference Duration | Perpetual RMSE      | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon RMSE     |
| :---------------------------------------------------------------------------------- | :-------------------------- | :--------------------------- | :------------------ | :-------------------------- | :--------------------------- | :----------------- |
| <a href="https://www.openml.org/t/359929" target="_blank">Airlines_DepDelay_10M</a> | 518                         | 11.3                         | 29.0                | 520                         | 30.9                         | <ins> 28.8 </ins>  |
| <a href="https://www.openml.org/t/361940" target="_blank">bates_regr_100</a>        | 3421                        | 15.1                         | <ins> 1.084 </ins>  | OOM                         | OOM                          | OOM                |
| <a href="https://www.openml.org/t/7327" target="_blank">BNG(libras_move)</a>        | 1956                        | 4.2                          | <ins> 2.51 </ins>   | 1922                        | 97.6                         | 2.53               |
| <a href="https://www.openml.org/t/7326" target="_blank">BNG(satellite_image)</a>    | 334                         | 1.6                          | 0.731               | 337                         | 10.0                         | <ins> 0.721 </ins> |
| <a href="https://www.openml.org/t/14949" target="_blank">COMET_MC</a>               | 44                          | 1.0                          | <ins> 0.0615 </ins> | 47                          | 5.0                          | 0.0662             |
| <a href="https://www.openml.org/t/361939" target="_blank">friedman1</a>             | 275                         | 4.2                          | <ins> 1.047 </ins>  | 278                         | 5.1                          | 1.487              |
| <a href="https://www.openml.org/t/10102" target="_blank">poker</a>                  | 38                          | 0.6                          | <ins> 0.256 </ins>  | 41                          | 1.2                          | 0.722              |
| <a href="https://www.openml.org/t/361955" target="_blank">subset_higgs</a>          | 868                         | 10.6                         | <ins> 0.420 </ins>  | 870                         | 24.5                         | 0.421              |
| <a href="https://www.openml.org/t/7319" target="_blank">BNG(autoHorse)</a>          | 107                         | 1.1                          | <ins> 19.0 </ins>   | 107                         | 3.2                          | 20.5               |
| <a href="https://www.openml.org/t/7318" target="_blank">BNG(pbc)</a>                | 48                          | 0.6                          | <ins> 836.5 </ins>  | 51                          | 0.2                          | 957.1              |
| average                                                                             | 465                         | 3.9                          | -                   | 464                         | 19.7                         | -                  |

PerpetualBooster outperformed AutoGluon on 8 out of 10 regression tasks, training equally fast and inferring 5.1x faster.

The results are summarized in the following table for classification tasks:

| OpenML Task                                                                        | Perpetual Training Duration | Perpetual Inference Duration | Perpetual AUC      | AutoGluon Training Duration | AutoGluon Inference Duration | AutoGluon AUC |
| :--------------------------------------------------------------------------------- | :-------------------------- | :--------------------------- | :----------------- | :-------------------------- | :--------------------------- | :------------ |
| <a href="https://www.openml.org/t/146163" target="_blank">BNG(spambase)</a>        | 70.1                        | 2.1                          | <ins> 0.671 </ins> | 73.1                        | 3.7                          | 0.669         |
| <a href="https://www.openml.org/t/208" target="_blank">BNG(trains)</a>             | 89.5                        | 1.7                          | <ins> 0.996 </ins> | 106.4                       | 2.4                          | 0.994         |
| <a href="https://www.openml.org/t/361942" target="_blank">breast</a>               | 13699.3                     | 97.7                         | <ins> 0.991 </ins> | 13330.7                     | 79.7                         | 0.949         |
| <a href="https://www.openml.org/t/7291" target="_blank">Click_prediction_small</a> | 89.1                        | 1.0                          | <ins> 0.749 </ins> | 101.0                       | 2.8                          | 0.703         |
| <a href="https://www.openml.org/t/361938" target="_blank">colon</a>                | 12435.2                     | 126.7                        | <ins> 0.997 </ins> | 12356.2                     | 152.3                        | 0.997         |
| <a href="https://www.openml.org/t/362113" target="_blank">Higgs</a>                | 3485.3                      | 40.9                         | <ins> 0.843 </ins> | 3501.4                      | 67.9                         | 0.816         |
| <a href="https://www.openml.org/t/230" target="_blank">SEA(50000)</a>              | 21.9                        | 0.2                          | <ins> 0.936 </ins> | 25.6                        | 0.5                          | 0.935         |
| <a href="https://www.openml.org/t/359994" target="_blank">sf-police-incidents</a>  | 85.8                        | 1.5                          | <ins> 0.687 </ins> | 99.4                        | 2.8                          | 0.659         |
| <a href="https://www.openml.org/t/361941" target="_blank">bates_classif_100</a>    | 11152.8                     | 50.0                         | <ins> 0.864 </ins> | OOM                         | OOM                          | OOM           |
| <a href="https://www.openml.org/t/361945" target="_blank">prostate</a>             | 13699.9                     | 79.8                         | <ins> 0.987 </ins> | OOM                         | OOM                          | OOM           |
| average                                                                            | 3747.0                      | 34.0                         | -                  | 3699.2                      | 39.0                         | -             |

PerpetualBooster outperformed AutoGluon on 10 out of 10 classification tasks, training equally fast and inferring 1.1x faster.

PerpetualBooster demonstrates greater robustness compared to AutoGluon, successfully training on all 20 tasks, whereas AutoGluon encountered out-of-memory errors on 3 of those tasks.

The results can be reproduced using the <a href="https://github.com/deadsoul44/automlbenchmark" target="_blank">automlbenchmark fork</a>.

## Contribution

Contributions are welcome. Check <a href="./CONTRIBUTING.md" target="_blank">CONTRIBUTING.md</a> for the guideline.

## Paper

PerpetualBooster prevents overfitting with a generalization algorithm. The paper is work-in-progress to explain how the algorithm works. Check our <a href="https://perpetual-ml.com/blog/how-perpetual-works" target="_blank">blog post</a> for a high level introduction to the algorithm.

## Perpetual ML Suite

The **Perpetual ML Suite** is a comprehensive, batteries-included ML platform designed to deliver maximum predictive power with minimal effort. It allows you to track experiments, monitor metrics, and manage model drift through an intuitive interface.

For a fully managed, **serverless ML experience**, visit <a href="https://app.perpetual-ml.com" target="_blank">app.perpetual-ml.com</a>.

- **Serverless Marimo Notebooks**: Run interactive, reactive notebooks without managing any infrastructure.
- **Serverless ML Endpoints**: One-click deployment of models as production-ready endpoints for real-time inference.

Perpetual is also designed to live where your data lives. It is available as a native application on the <a href="https://app.snowflake.com/marketplace/listing/GZSYZX0EMJ/perpetual-ml-perpetual-ml-suite" target="_blank">Snowflake Marketplace</a>, with support for Databricks and other major data warehouses coming soon.

# Perpetual R Package Examples

This directory contains runnable examples demonstrating the Perpetual gradient boosting library in R.
All examples use R's built-in datasets, so you can copy and run them immediately without any setup.

## Prerequisites

Install the perpetual package:

```r
# Install from source (from package-r directory)
install.packages(".", repos = NULL, type = "source")

# Or install rextendr and build
# install.packages("rextendr")
# rextendr::document()
```

## Examples

| File | Description | Dataset | Task |
| ---- | ----------- | ------- | ---- |
| `01_binary_classification.R` | Binary classification | `mtcars` | Predict transmission type |
| `02_multiclass_classification.R` | Multiclass classification | `iris` | Predict flower species |
| `03_regression.R` | Regression | `mtcars` | Predict fuel efficiency (mpg) |
| `04_feature_importance.R` | Feature importance analysis | `mtcars` | Analyze feature contributions |
| `05_shap_contributions.R` | SHAP-style contributions | `iris` | Explain individual predictions |
| `06_save_load_model.R` | Model persistence | `mtcars` | Save and load models |
| `07_prediction_intervals.R` | Regression with airquality | `airquality` | Predict ozone levels |
| `08_budget_comparison.R` | Effect of training budget | `airquality` | Compare model complexity |

## Running Examples

Simply source any example file:

```r
source("examples/01_binary_classification.R")
```

Or run interactively in RStudio by opening the file and pressing Ctrl+Shift+Enter.

## Key Functions

- `perpetual()` - Train a model
- `predict()` - Make predictions (supports types: `"class"`, `"prob"`, `"raw"`, `"contribution"`)
- `perpetual_save()` / `perpetual_load()` - Model persistence
- `perpetual_importance()` - Feature importance

## Objectives

- `"LogLoss"` - Binary/multiclass classification
- `"SquaredLoss"` - Regression

# Advanced Regression Example with Perpetual
# Comparing model performance with different training budgets

library(perpetual)

# Prepare data using airquality dataset (predicting Ozone levels)
data(airquality)
aq <- na.omit(airquality)
X <- as.matrix(aq[, c("Solar.R", "Wind", "Temp", "Month", "Day")])
y <- aq$Ozone

# Split into train/test
set.seed(42)
n <- nrow(X)
train_idx <- sample(n, size = floor(0.8 * n))
X_train <- X[train_idx, ]
y_train <- y[train_idx]
X_test <- X[-train_idx, ]
y_test <- y[-train_idx]

# Train models with different budgets to see effect on complexity vs performance
budgets <- c(0.1, 0.5, 1.0, 2.0)
results <- data.frame(
  Budget = numeric(),
  Trees = numeric(),
  RMSE = numeric(),
  R2 = numeric()
)

cat("Training models with different budgets...\n\n")

for (b in budgets) {
  model <- perpetual(
    x = X_train,
    y = y_train,
    objective = "SquaredLoss",
    budget = b
  )
  
  preds <- predict(model, X_test, type = "raw")
  rmse <- sqrt(mean((preds - y_test)^2))
  
  ss_res <- sum((y_test - preds)^2)
  ss_tot <- sum((y_test - mean(y_test))^2)
  r2 <- 1 - (ss_res / ss_tot)
  
  results <- rbind(results, data.frame(
    Budget = b,
    Trees = model$number_of_trees(),
    RMSE = round(rmse, 2),
    R2 = round(r2, 3)
  ))
}

cat("--- Results by Training Budget ---\n")
print(results)

cat("\nNote: Higher budget allows longer training and more trees,\n")
cat("which can improve performance but may risk overfitting.\n")
cat("The budget parameter controls the stopping criterion.\n")

# Feature Importance Example with Perpetual
# Using the built-in 'mtcars' dataset

library(perpetual)

# Prepare data
data(mtcars)
feature_names <- c("cyl", "disp", "hp", "wt", "qsec", "gear", "carb")
X <- as.matrix(mtcars[, feature_names])
y <- mtcars$mpg

# Train model
cat("Training model for feature importance analysis...\n")
model <- perpetual(
  x = X,
  y = y,
  objective = "SquaredLoss",
  budget = 1.0
)

print(model)

# Get feature importance using different methods
cat("\n--- Feature Importance (Gain) ---\n")
imp_gain <- perpetual_importance(model, method = "gain", normalize = TRUE)
# Map feature indices to names
names(imp_gain) <- feature_names[as.numeric(names(imp_gain)) + 1]
print(sort(imp_gain, decreasing = TRUE))

cat("\n--- Feature Importance (Weight) ---\n")
imp_weight <- perpetual_importance(model, method = "weight", normalize = TRUE)
names(imp_weight) <- feature_names[as.numeric(names(imp_weight)) + 1]
print(sort(imp_weight, decreasing = TRUE))

cat("\n--- Feature Importance (Cover) ---\n")
imp_cover <- perpetual_importance(model, method = "cover", normalize = TRUE)
names(imp_cover) <- feature_names[as.numeric(names(imp_cover)) + 1]
print(sort(imp_cover, decreasing = TRUE))

# Simple bar plot if available
if (interactive()) {
  barplot(
    sort(imp_gain, decreasing = TRUE),
    main = "Feature Importance (Gain)",
    xlab = "Features",
    ylab = "Importance",
    las = 2,
    col = "steelblue"
  )
}

# Helper functions to load test data from resources directory
# These match the data used in Python tests

library(perpetual)

get_resources_dir <- function() {
  # During tests, resources are copied to tests/testthat/resources
  # testthat tests run with getwd() as tests/testthat (usually) or tests/
  
  candidates <- c(
    "resources",
    "tests/testthat/resources",
    "../resources",
    "../../resources",
    "../../../resources",
    "./testthat/resources"
  )
  
  for (path in candidates) {
    if (dir.exists(path)) {
      # Normalize path
      return(normalizePath(path))
    }
  }
  
  return(NULL)
}

skip_if_no_resources <- function() {
  if (is.null(get_resources_dir())) {
    testthat::skip("Test resources not found!")
  }
}

# Helper to convert flat data list to matrix for new API
as_matrix_data <- function(data) {
  X <- matrix(data$flat_data, nrow = data$rows, ncol = data$cols, byrow = FALSE)
  storage.mode(X) <- "double"
  list(X = X, y = data$y)
}

# Load Titanic test data (matches Python test_booster.py test_categorical)
load_titanic_test_data <- function() {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  
  # Read the flat CSV (column-major values)
  flat_file <- file.path(resources_dir, "titanic_test_flat.csv")
  y_file <- file.path(resources_dir, "titanic_test_y.csv")
  
  lines_flat <- readLines(flat_file)
  lines_flat <- lines_flat[grep("\\S", lines_flat)]
  lines_flat[lines_flat == "\"\"" | lines_flat == ""] <- NA
  flat_data <- as.numeric(lines_flat)
  
  lines_y <- readLines(y_file)
  lines_y <- lines_y[grep("\\S", lines_y)]
  lines_y[lines_y == "\"\"" | lines_y == ""] <- NA
  y <- as.numeric(lines_y)
  
  # titanic_test has 178 rows, need to determine cols
  rows <- length(y)
  cols <- length(flat_data) / rows
  
  list(flat_data = flat_data, rows = rows, cols = as.integer(cols), y = y)
}

# Load Titanic training data
load_titanic_train_data <- function() {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  
  flat_file <- file.path(resources_dir, "titanic_train_flat.csv")
  y_file <- file.path(resources_dir, "titanic_train_y.csv")
  
  lines_flat <- readLines(flat_file)
  lines_flat <- lines_flat[grep("\\S", lines_flat)]
  lines_flat[lines_flat == "\"\"" | lines_flat == ""] <- NA
  flat_data <- as.numeric(lines_flat)
  
  lines_y <- readLines(y_file)
  lines_y <- lines_y[grep("\\S", lines_y)]
  lines_y[lines_y == "\"\"" | lines_y == ""] <- NA
  y <- as.numeric(lines_y)
  
  rows <- length(y)
  cols <- length(flat_data) / rows
  
  list(flat_data = flat_data, rows = rows, cols = as.integer(cols), y = y)
}

# Load Cover Types data for multi-class classification (matches Python test_multi_output.py)
load_cover_types_data <- function(n_samples = 1000, seed = 0) {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  
  train_file <- file.path(resources_dir, "cover_types_train.csv")
  test_file <- file.path(resources_dir, "cover_types_test.csv")
  
  # Read CSV with header
  train_df <- read.csv(train_file, header = TRUE)
  test_df <- read.csv(test_file, header = TRUE)
  
  # Sample training data like Python test
  set.seed(seed)
  if (nrow(train_df) > n_samples) {
    train_df <- train_df[sample(nrow(train_df), n_samples), ]
  }
  
  # Extract y (Cover_Type column)
  y_train <- train_df$Cover_Type
  y_test <- test_df$Cover_Type
  
  # Remove target column for X
  X_train <- train_df[, !names(train_df) %in% c("Cover_Type")]
  X_test <- test_df[, !names(test_df) %in% c("Cover_Type")]
  
  # Convert to numeric matrix and flatten (column-major for R)
  X_train_mat <- as.matrix(X_train)
  storage.mode(X_train_mat) <- "double"
  X_test_mat <- as.matrix(X_test)
  storage.mode(X_test_mat) <- "double"
  
  list(
    train = list(
      flat_data = as.vector(X_train_mat),
      rows = nrow(X_train_mat),
      cols = ncol(X_train_mat),
      y = as.numeric(y_train)
    ),
    test = list(
      flat_data = as.vector(X_test_mat),
      rows = nrow(X_test_mat),
      cols = ncol(X_test_mat),
      y = as.numeric(y_test)
    )
  )
}

# Load California Housing data for regression (matches Python test_calibration)
load_cal_housing_data <- function() {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  
  train_file <- file.path(resources_dir, "cal_housing_train.csv")
  test_file <- file.path(resources_dir, "cal_housing_test.csv")
  
  # Read CSV with header
  train_df <- read.csv(train_file, header = TRUE)
  test_df <- read.csv(test_file, header = TRUE)
  
  # Target column is MedHouseVal
  y_train <- train_df$MedHouseVal
  y_test <- test_df$MedHouseVal
  
  # Remove target column for X
  X_train <- train_df[, !names(train_df) %in% c("MedHouseVal")]
  X_test <- test_df[, !names(test_df) %in% c("MedHouseVal")]
  
  # Convert to numeric matrix and flatten
  X_train_mat <- as.matrix(X_train)
  X_test_mat <- as.matrix(X_test)
  
  list(
    train = list(
      flat_data = as.vector(X_train_mat),
      rows = nrow(X_train_mat),
      cols = ncol(X_train_mat),
      y = as.numeric(y_train)
    ),
    test = list(
      flat_data = as.vector(X_test_mat),
      rows = nrow(X_test_mat),
      cols = ncol(X_test_mat),
      y = as.numeric(y_test)
    )
  )
}

# Backward compatibility tests using XGBoost/LightGBM style API
# Replicating Python test_backward_compatibility.py
# Tests loading pre-saved model from v2.0.0

test_that("Load v2.0.0 model and verify predictions", {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  model_path <- file.path(resources_dir, "model_bc.json")
  preds_path <- file.path(resources_dir, "model_bc_preds.csv")
  probs_path <- file.path(resources_dir, "model_bc_probs.csv")
  
  skip_if_not(file.exists(model_path), "Model artifact not found. Run scripts/make_resources.py to generate it.")
  skip_if_not(file.exists(preds_path), "Predictions artifact not found.")
  
  # Load the model
  model <- PerpetualBooster$load_booster(model_path)
  
  # Verify model loaded correctly
  expect_true(!is.null(model))
  n_trees <- perpetual_n_trees(model)
  expect_true(n_trees > 0)
  
  base <- perpetual_base_score(model)
  expect_true(is.numeric(base))
})

test_that("V2.0.0 model JSON is valid", {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  model_path <- file.path(resources_dir, "model_bc.json")
  
  skip_if_not(file.exists(model_path), "Model artifact not found.")
  
  # Read and parse JSON directly
  json_content <- readLines(model_path, warn = FALSE)
  json_str <- paste(json_content, collapse = "\n")
  parsed <- jsonlite::fromJSON(json_str, simplifyVector = FALSE)
  
  # Verify structure
  expect_true("trees" %in% names(parsed))
  expect_true("base_score" %in% names(parsed))
  expect_true(length(parsed$trees) > 0)
})

test_that("Loaded model can make predictions with new API", {
  skip_if_no_resources()
  resources_dir <- get_resources_dir()
  model_path <- file.path(resources_dir, "model_bc.json")
  
  skip_if_not(file.exists(model_path), "Model artifact not found.")
  
  model <- PerpetualBooster$load_booster(model_path)
  
  # Load titanic test data
  data <- as_matrix_data(load_titanic_test_data())
  
  # This will work if the number of features matches
  tryCatch({
    preds <- predict(model, data$X, type = "raw")
    expect_true(length(preds) == nrow(data$X))
    expect_true(!any(is.na(preds)))
  }, error = function(e) {
    # If feature count doesn't match, that's expected
    skip("Model feature count doesn't match test data - expected for v2.0.0 model")
  })
})

# Contribution tests using XGBoost/LightGBM style API
# Replicating Python test_booster.py contribution tests

test_that("predict(type='contribution') returns correct shape", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "average")
  
  # Should return (n_samples x (n_features + 1)) matrix - last column is bias
  expect_true(is.matrix(contribs))
  expect_equal(nrow(contribs), nrow(data$X))
  expect_equal(ncol(contribs), ncol(data$X) + 1)
})

test_that("predict(type='contribution') average method returns valid values", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "average")
  
  expect_true(is.matrix(contribs))
  expect_true(!any(is.na(contribs)))
  expect_true(all(is.finite(contribs)))
})

test_that("predict(type='contribution') weight method works", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "weight")
  
  expect_true(is.matrix(contribs))
  expect_true(!any(is.na(contribs)))
})

test_that("predict(type='contribution') branchdifference method works", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "branchdifference")
  
  expect_true(is.matrix(contribs))
  expect_true(!any(is.na(contribs)))
})

test_that("predict(type='contribution') shapley method works", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "shapley")
  
  expect_true(is.matrix(contribs))
  expect_true(!any(is.na(contribs)))
})

test_that("predict(type='contribution') probabilitychange method works for LogLoss", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  contribs <- predict(model, data$X, type = "contribution", method = "probabilitychange")
  
  expect_true(is.matrix(contribs))
  expect_true(!any(is.na(contribs)))
})

# Serialize tests replicating Python test_serialize.py
# R implementation using jsonlite for JSON serialization

test_that("Scalar values serialize/deserialize correctly", {
  values <- list(
    1L,
    1.0,
    1.00101,
    "a string",
    TRUE,
    FALSE,
    NULL
  )
  
  for (value in values) {
    json_str <- jsonlite::toJSON(value, auto_unbox = TRUE, null = "null")
    expect_true(is.character(json_str))
    
    restored <- jsonlite::fromJSON(json_str)
    if (is.null(value)) {
      expect_null(restored)
    } else if (is.logical(value)) {
      expect_equal(as.logical(restored), value)
    } else if (is.character(value)) {
      expect_equal(as.character(restored), value)
    } else {
      # Use tolerance for numeric comparison as JSON roundtrip might change precision
      expect_equal(as.numeric(restored), as.numeric(value), tolerance = 1e-4)
    }
  }
})

test_that("Object values serialize/deserialize correctly", {
  values <- list(
    c(1, 2, 3),
    c(1.0, 4.0),
    c("a", "b", "c"),
    list(a = 1.0, b = 2.0),
    list(a = "test", b = "what")
  )
  
  for (value in values) {
    json_str <- jsonlite::toJSON(value, auto_unbox = TRUE)
    expect_true(is.character(json_str))
    
    restored <- jsonlite::fromJSON(json_str)
    
    if (is.list(value) && !is.null(names(value))) {
      # Named list (dict-like)
      expect_equal(as.list(restored), value, tolerance = 1e-10)
    } else {
      # Vector or unnamed list
      expect_equal(as.vector(restored), as.vector(value), tolerance = 1e-10)
    }
  }
})

test_that("Numeric arrays serialize/deserialize correctly", {
  values <- list(
    c(1.0, 2.23),
    matrix(1:6, nrow = 2, ncol = 3),
    matrix(as.integer(1:6), nrow = 2, ncol = 3)
  )
  
  for (value in values) {
    json_str <- jsonlite::toJSON(value)
    expect_true(is.character(json_str))
    
    restored <- jsonlite::fromJSON(json_str)
    
    if (is.matrix(value)) {
      restored <- matrix(restored, nrow = nrow(value), ncol = ncol(value))
    }
    
    expect_equal(as.vector(restored), as.vector(value), tolerance = 1e-10)
  }
})

test_that("Model JSON contains expected structure", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  json_str <- perpetual_to_json(model)
  parsed <- jsonlite::fromJSON(json_str, simplifyVector = FALSE)
  
  # Check expected fields exist
  expect_true("trees" %in% names(parsed))
  expect_true("base_score" %in% names(parsed))
  expect_true("cfg" %in% names(parsed))
})

# Save and Load Model Example with Perpetual
# Demonstrates model persistence

library(perpetual)

# Prepare data
data(mtcars)
X <- as.matrix(mtcars[, c("cyl", "disp", "hp", "wt", "qsec")])
y <- mtcars$mpg

# Train model
cat("Training model...\n")
model <- perpetual(
  x = X,
  y = y,
  objective = "SquaredLoss",
  budget = 0.5
)

print(model)

# Make predictions before saving
pred_before <- predict(model, X[1:3, ], type = "raw")
cat("\nPredictions before saving:\n")
print(round(pred_before, 4))

# Save model to a temporary file
model_path <- tempfile(fileext = ".json")
cat("\nSaving model to:", model_path, "\n")
perpetual_save(model, model_path)

# Check file was created
cat("Model file size:", file.size(model_path), "bytes\n")

# Load model back
cat("\nLoading model from file...\n")
loaded_model <- perpetual_load(model_path)
print(loaded_model)

# Make predictions with loaded model
pred_after <- predict(loaded_model, X[1:3, ], type = "raw")
cat("\nPredictions after loading:\n")
print(round(pred_after, 4))

# Verify predictions match
if (all(abs(pred_before - pred_after) < 1e-6)) {
  cat("\n✓ Predictions match! Model saved and loaded successfully.\n")
} else {
  cat("\n✗ Predictions differ. Something went wrong.\n")
}

# Clean up
unlink(model_path)
cat("\nTemporary model file deleted.\n")

# Prediction Intervals Example with Perpetual
# Using the built-in 'airquality' dataset for regression with uncertainty

library(perpetual)

# Prepare data - predict Ozone from other variables
data(airquality)
# Remove rows with missing values for simplicity
aq <- na.omit(airquality)
X <- as.matrix(aq[, c("Solar.R", "Wind", "Temp", "Month", "Day")])
y <- aq$Ozone

# Split into train/calibration/test
set.seed(42)
n <- nrow(X)
train_idx <- sample(n, size = floor(0.6 * n))
remaining <- setdiff(1:n, train_idx)
cal_idx <- remaining[1:floor(length(remaining)/2)]
test_idx <- remaining[(floor(length(remaining)/2)+1):length(remaining)]

X_train <- X[train_idx, ]
y_train <- y[train_idx]
X_cal <- X[cal_idx, ]
y_cal <- y[cal_idx]
X_test <- X[test_idx, ]
y_test <- y[test_idx]

cat("Train:", length(y_train), "samples\n")
cat("Calibration:", length(y_cal), "samples\n")
cat("Test:", length(y_test), "samples\n")

# Train model
cat("\nTraining regression model...\n")
model <- perpetual(
  x = X_train,
  y = y_train,
  objective = "SquaredLoss",
  budget = 1.0
)

print(model)

# Make point predictions
point_preds <- predict(model, X_test, type = "raw")

# Display predictions vs actual
cat("\n--- Predictions vs Actual (first 10 samples) ---\n")
results <- data.frame(
  Actual = y_test[1:10],
  Predicted = round(point_preds[1:10], 1),
  Error = round(y_test[1:10] - point_preds[1:10], 1)
)
print(results)

# Calculate RMSE
rmse <- sqrt(mean((point_preds - y_test)^2))
cat("\nRMSE:", round(rmse, 2), "\n")

# Calculate R-squared
ss_res <- sum((y_test - point_preds)^2)
ss_tot <- sum((y_test - mean(y_test))^2)
r_squared <- 1 - (ss_res / ss_tot)
cat("R-squared:", round(r_squared, 3), "\n")

# Note: For conformal prediction intervals, use the perpetual_calibrate() function
# after training. This example shows basic prediction - see documentation for
# full calibration workflow.

# SHAP-style Feature Contributions Example with Perpetual
# Using the built-in 'iris' dataset

library(perpetual)

# Prepare data - binary classification (setosa vs non-setosa)
data(iris)
X <- as.matrix(iris[, 1:4])
y <- as.numeric(iris$Species == "setosa")  # 1 if setosa, 0 otherwise

# Train model
cat("Training model for SHAP contributions...\n")
model <- perpetual(
  x = X,
  y = y,
  objective = "LogLoss",
  budget = 0.5
)

print(model)

# Get SHAP-style contributions for predictions
# type = "contribution" returns a matrix (n_samples x (n_features + 1))
# The last column is the bias term
contributions <- predict(model, X[1:5, ], type = "contribution")

# Add column names
feature_names <- colnames(iris)[1:4]
colnames(contributions) <- c(feature_names, "bias")

cat("\n--- SHAP-style Contributions (first 5 samples) ---\n")
print(round(contributions, 4))

# Show how contributions sum to predictions
cat("\n--- Verification: Contributions sum to predictions ---\n")
predictions <- predict(model, X[1:5, ], type = "raw")
contribution_sums <- rowSums(contributions)

comparison <- data.frame(
  Sample = 1:5,
  Prediction = round(predictions, 4),
  ContributionSum = round(contribution_sums, 4),
  Difference = round(predictions - contribution_sums, 6)
)
print(comparison)

# Analyze feature impact for a single prediction
cat("\n--- Feature Impact for Sample 1 ---\n")
sample_1_contrib <- contributions[1, ]
cat("Sample 1 (", ifelse(y[1] == 1, "setosa", "not setosa"), "):\n", sep = "")
for (i in seq_along(sample_1_contrib)) {
  cat(sprintf("  %-15s: %+.4f\n", names(sample_1_contrib)[i], sample_1_contrib[i]))
}

# Regression Example with Perpetual
# Using the built-in 'mtcars' dataset to predict fuel efficiency (mpg)

library(perpetual)

# Prepare data
data(mtcars)
X <- as.matrix(mtcars[, c("cyl", "disp", "hp", "wt", "qsec", "gear", "carb")])
y <- mtcars$mpg

# Split into train/test
set.seed(42)
train_idx <- sample(nrow(X), size = 24)
X_train <- X[train_idx, ]
y_train <- y[train_idx]
X_test <- X[-train_idx, ]
y_test <- y[-train_idx]

# Train a regression model with SquaredLoss
cat("Training regression model with SquaredLoss...\n")
model <- perpetual(
  x = X_train,
  y = y_train,
  objective = "SquaredLoss",
  budget = 1.0
)

# Print model summary
print(model)

# Predict
predictions <- predict(model, X_test, type = "raw")
cat("\nPredictions vs Actual (MPG):\n")
results <- data.frame(
  Actual = y_test,
  Predicted = round(predictions, 2),
  Error = round(y_test - predictions, 2)
)
print(results)

# Calculate RMSE
rmse <- sqrt(mean((predictions - y_test)^2))
cat("\nRMSE:", round(rmse, 3), "mpg\n")

# Calculate R-squared
ss_res <- sum((y_test - predictions)^2)
ss_tot <- sum((y_test - mean(y_test))^2)
r_squared <- 1 - (ss_res / ss_tot)
cat("R-squared:", round(r_squared, 3), "\n")

# Multiclass Classification Example with Perpetual
# Using the built-in 'iris' dataset to predict flower species

library(perpetual)

# Prepare data
data(iris)
X <- as.matrix(iris[, 1:4])  # Sepal.Length, Sepal.Width, Petal.Length, Petal.Width
y <- as.numeric(iris$Species)  # 1 = setosa, 2 = versicolor, 3 = virginica

# Split into train/test
set.seed(42)
train_idx <- sample(nrow(X), size = 120)
X_train <- X[train_idx, ]
y_train <- y[train_idx]
X_test <- X[-train_idx, ]
y_test <- y[-train_idx]

# Train a multiclass classification model
cat("Training multiclass classification model...\n")
model <- perpetual(
  x = X_train,
  y = y_train,
  objective = "LogLoss",
  budget = 1.0
)

# Print model summary
print(model)

# Predict class labels
pred_class <- predict(model, X_test, type = "class")
cat("\nPredicted classes:", pred_class, "\n")
cat("Actual classes:   ", y_test, "\n")

# Calculate accuracy
accuracy <- mean(pred_class == y_test)
cat("\nAccuracy:", round(accuracy * 100, 1), "%\n")

# Predict probabilities (returns matrix: rows = samples, cols = classes)
pred_prob <- predict(model, X_test, type = "prob")
cat("\nPredicted probabilities (first 5 samples):\n")
colnames(pred_prob) <- levels(iris$Species)
print(round(pred_prob[1:5, ], 3))

# Map numeric predictions back to species names for display
species_names <- levels(iris$Species)
pred_species <- species_names[pred_class]
actual_species <- species_names[y_test]
cat("\nPrediction comparison:\n")
print(data.frame(Actual = actual_species, Predicted = pred_species))

#!/usr/bin/env Rscript

lib_path <- file.path("package-r", "R_library")
if (dir.exists(lib_path)) {
  .libPaths(c(lib_path, .libPaths()))
}

if (!requireNamespace("roxygen2", quietly = TRUE)) {
  stop("roxygen2 is not installed. Please install it with install.packages('roxygen2')")
}

cat("Generating R documentation for 'package-r'...\n")
roxygen2::roxygenise("package-r")
cat("Documentation generation complete.\n")

#' Train a PerpetualBooster model
#'
#' Perpetual is a self-generalizing gradient boosting machine that doesn't need 
#' hyperparameter optimization. It automatically finds the best configuration 
#' based on the provided budget.
#'
#' @param x A matrix or data.frame of features.
#' @param y A vector of targets (numeric for regression, factor/integer for classification).
#' @param objective A string specifying the objective function. Default is "LogLoss".
#' @param budget A numeric value ensuring the training time does not exceed this budget (in normalized units).
#' @param iteration_limit An integer limit on the number of iterations.
#' @param stopping_rounds An integer for early stopping.
#' @param max_bin Integer, max number of bins for histograms.
#' @param num_threads Integer, number of threads to use.
#' @param missing Value to consider as missing data. Default is NaN.
#' @param allow_missing_splits Boolean.
#' @param create_missing_branch Boolean. Whether to create a separate branch for missing values (ternary trees).
#' @param missing_node_treatment String. How to handle weights for missing nodes if create_missing_branch is True. Options: "None", "AssignToParent", "AverageLeafWeight", "AverageNodeWeight".
#' @param log_iterations Integer.
#' @param quantile Numeric.
#' @param reset Boolean.
#' @param timeout Numeric.
#' @param memory_limit Numeric.
#' @param seed Integer seed for reproducibility.
#' @param calibration_method String specifying the calibration method for prediction intervals. Options: "WeightVariance", "MinMax", "GRP", "Conformal".
#' @param save_node_stats Boolean. Whether to save node statistics (required for some calibration methods and importance types).
#' @param ... Additional arguments.
#'
#' @return A \code{PerpetualBooster} object.
#' @export
perpetual <- function(x, y, objective = "LogLoss", budget = NULL, 
                      iteration_limit = NULL, stopping_rounds = NULL, 
                      max_bin = NULL, num_threads = NULL, missing = NULL,
                      allow_missing_splits = NULL, create_missing_branch = NULL,
                      missing_node_treatment = NULL, log_iterations = NULL,
                      quantile = NULL, reset = NULL, timeout = NULL,
                      memory_limit = NULL, seed = NULL, calibration_method = NULL, 
                      save_node_stats = NULL, ...) {
  if (is.data.frame(x)) {
    x <- as.matrix(x)
  }
  
  # Flatten and types for Rust
  storage.mode(x) <- "double"
  flat_data <- as.vector(x)
  rows <- nrow(x)
  cols <- ncol(x)
  y <- as.numeric(y)
  
  # Ensure integer types for optional parameters
  if (!is.null(iteration_limit)) iteration_limit <- as.integer(iteration_limit)
  if (!is.null(stopping_rounds)) stopping_rounds <- as.integer(stopping_rounds)
  if (!is.null(max_bin)) max_bin <- as.integer(max_bin)
  if (!is.null(num_threads)) num_threads <- as.integer(num_threads)
  if (!is.null(log_iterations)) log_iterations <- as.integer(log_iterations)
  if (!is.null(seed)) seed <- as.integer(seed)
  if (!is.null(save_node_stats)) save_node_stats <- as.logical(save_node_stats)
  
  # Detect classes for classification objectives
  classes <- sort(unique(y[!is.na(y)]))
  
  ptr <- .Call("PerpetualBooster_new",
        objective,
        budget,
        max_bin,
        num_threads,
        missing,
        allow_missing_splits,
        create_missing_branch,
        missing_node_treatment,
        log_iterations,
        quantile,
        reset,
        timeout,
        iteration_limit,
        memory_limit,
        stopping_rounds,
        seed,
        calibration_method,
        save_node_stats,
        PACKAGE = "perpetual"
  )
  
  # Create a lightweight R6-like object (just a list with class)
  model <- structure(list(.ptr = ptr), class = "PerpetualBooster")
  
  # Fit
  .Call("PerpetualBooster_fit", ptr, flat_data, as.integer(rows), as.integer(cols), y, PACKAGE = "perpetual")
  
  # Store classes and objective
  attr(model, "classes") <- classes
  attr(model, "objective") <- objective
  
  return(model)
}

#' Predict using a PerpetualBooster model
#'
#' @param object A \code{PerpetualBooster} object.
#' @param newdata A matrix or data.frame of new data to predict on.
#' @param type Type of prediction: "class", "prob", "raw", "contribution", or "interval".
#' @param method Method for prediction contributions. Default "average".
#' @param ... Additional arguments.
#'
#' @return A vector or matrix of predictions.
#' @export
predict.PerpetualBooster <- function(object, newdata, type = c("class", "prob", "raw", "contribution", "interval"), method = "average", ...) {
  type <- match.arg(type)
  
  if (is.data.frame(newdata)) {
    newdata <- as.matrix(newdata)
  }
  storage.mode(newdata) <- "double"
  flat_data <- as.vector(newdata)
  rows <- nrow(newdata)
  cols <- ncol(newdata)
  
  raw_preds <- .Call("PerpetualBooster_predict", object$.ptr, flat_data, as.integer(rows), as.integer(cols), PACKAGE = "perpetual")
  
  classes <- attr(object, "classes")
  objective <- attr(object, "objective")
  
  if (type == "raw") {
    return(raw_preds)
  }
  
  if (type == "contribution") {
    contribs <- .Call("PerpetualBooster_predict_contributions", object$.ptr, flat_data, as.integer(rows), as.integer(cols), method, PACKAGE = "perpetual")
    contrib_mat <- matrix(contribs, nrow = rows, ncol = cols + 1, byrow = FALSE)
    return(contrib_mat)
  }
  
  if (type == "interval") {
    intervals <- .Call("PerpetualBooster_predict_intervals", object$.ptr, flat_data, as.integer(rows), as.integer(cols), PACKAGE = "perpetual")
    return(intervals)
  }
  
  if (is.null(classes) || length(classes) == 0) {
    if (type == "prob") {
      probs <- 1 / (1 + exp(-raw_preds))
      return(probs)
    } else {
      return(raw_preds)
    }
  }
  
  if (length(classes) <= 2) {
    if (length(classes) == 2 && !is.null(objective) && objective == "LogLoss") {
      probs <- 1 / (1 + exp(-raw_preds))
      if (type == "prob") {
        return(probs)
      } else {
        return(ifelse(probs >= 0.5, classes[2], classes[1]))
      }
    } else {
      return(raw_preds)
    }
  } else {
    n_classes <- length(classes)
    if (type == "prob") {
      probs_flat <- .Call("PerpetualBooster_predict_proba", object$.ptr, flat_data, as.integer(rows), as.integer(cols), PACKAGE = "perpetual")
      probs <- matrix(probs_flat, nrow = rows, ncol = n_classes, byrow = FALSE)
      row_sums <- rowSums(probs)
      probs <- probs / row_sums
      return(probs)
    } else {
      preds_mat <- matrix(raw_preds, nrow = rows, ncol = n_classes, byrow = FALSE)
      max_idx <- max.col(preds_mat, ties.method = "first")
      return(classes[max_idx])
    }
  }
}

#' Print PerpetualBooster
#'
#' @param x A \code{PerpetualBooster} object.
#' @param ... Additional arguments.
#'
#' @export
print.PerpetualBooster <- function(x, ...) {
  n_trees <- .Call("PerpetualBooster_number_of_trees", x$.ptr, PACKAGE = "perpetual")
  base_score <- .Call("PerpetualBooster_base_score", x$.ptr, PACKAGE = "perpetual")

  cat("Perpetual Boosting Machine model\n")
  cat("Number of trees: ", n_trees, "\n")
  cat("Base score: ", base_score, "\n")
  classes <- attr(x, "classes")
  if (!is.null(classes) && length(classes) > 0) {
    cat("Classes: ", paste(classes, collapse = ", "), "\n")
  }
  invisible(x)
}

#' Save a PerpetualBooster model
#'
#' @param model A \code{PerpetualBooster} object.
#' @param path String, path to save the model.
#'
#' @export
perpetual_save <- function(model, path) {
  if (!inherits(model, "PerpetualBooster")) {
    stop("model must be a PerpetualBooster object")
  }
  .Call("PerpetualBooster_save_booster", model$.ptr, path, PACKAGE = "perpetual")
}

#' Load a PerpetualBooster model
#'
#' @param path String, path to the saved model.
#'
#' @return A \code{PerpetualBooster} object.
#' @export
perpetual_load <- function(path) {
  if (!file.exists(path)) {
    stop("File not found: ", path)
  }
  
  ptr <- .Call("PerpetualBooster_load_booster", path, PACKAGE = "perpetual")
  model <- structure(list(.ptr = ptr), class = "PerpetualBooster")
  
  classes <- .Call("PerpetualBooster_get_classes", model$.ptr, PACKAGE = "perpetual")
  if (length(classes) > 0) {
    attr(model, "classes") <- classes
  }
  
  objective <- .Call("PerpetualBooster_get_objective", model$.ptr, PACKAGE = "perpetual")
  if (!is.null(objective) && nzchar(objective)) {
    attr(model, "objective") <- objective
  }
  
  return(model)
}

#' Calibrate a PerpetualBooster model
#'
#' @param model A \code{PerpetualBooster} object.
#' @param x Validation features.
#' @param y Validation targets.
#' @param x_cal Calibration features.
#' @param y_cal Calibration targets.
#' @param alpha Calibration parameter.
#' @param method String specifying the calibration method to use. If NULL, uses the method configured in the model.
#'
#' @export
perpetual_calibrate <- function(model, x, y, x_cal, y_cal, alpha, method = NULL) {
  if (is.data.frame(x)) x <- as.matrix(x)
  if (is.data.frame(x_cal)) x_cal <- as.matrix(x_cal)
  storage.mode(x) <- "double"
  storage.mode(x_cal) <- "double"
  
  .Call("PerpetualBooster_calibrate", model$.ptr, 
        as.vector(x), as.integer(nrow(x)), as.integer(ncol(x)), as.numeric(y),
        as.vector(x_cal), as.integer(nrow(x_cal)), as.integer(ncol(x_cal)), as.numeric(y_cal),
        as.numeric(alpha), method, PACKAGE = "perpetual")
  invisible(model)
}

#' Get feature importance
#'
#' @param model A \code{PerpetualBooster} object.
#' @param method String, method for importance (e.g. "gain").
#' @param normalize Boolean.
#'
#' @return A named vector of importances.
#' @export
perpetual_importance <- function(model, method = "gain", normalize = TRUE) {
  imp <- .Call("PerpetualBooster_calculate_feature_importance", model$.ptr, method, normalize, PACKAGE = "perpetual")
  # imp is a list (from Rust) but with names. Wait, in Rust we returned a Named Vector!
  # So imp is a named numeric vector
  return(imp)
}

#' Get the number of trees in the model
#'
#' @param model A \code{PerpetualBooster} object.
#' @return Integer, number of trees.
#' @export
perpetual_n_trees <- function(model) {
  .Call("PerpetualBooster_number_of_trees", model$.ptr, PACKAGE = "perpetual")
}

#' Get the base score of the model
#'
#' @param model A \code{PerpetualBooster} object.
#' @return Numeric, base score.
#' @export
perpetual_base_score <- function(model) {
  .Call("PerpetualBooster_base_score", model$.ptr, PACKAGE = "perpetual")
}

#' Dump model to JSON string
#'
#' @param model A \code{PerpetualBooster} object.
#' @return String, JSON representation of the model.
#' @export
perpetual_to_json <- function(model) {
  .Call("PerpetualBooster_json_dump", model$.ptr, PACKAGE = "perpetual")
}

#' PerpetualBooster
#'
#' PerpetualBooster object for creating and loading models.
#'
#' @export
PerpetualBooster <- list(
    new = function(...) {
        perpetual(...)
    },
    load_booster = function(path) {
        perpetual_load(path)
    }
)

# Multiclass classification tests using XGBoost/LightGBM style API

test_that("Multiclass prediction with perpetual() and predict()", {
  X <- as.matrix(iris[, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[, 5])  # 1, 2, 3 (3 classes)
  
  model <- perpetual(X, y, objective = "LogLoss")
  
  # Class predictions should return labels for each sample
  preds_class <- predict(model, X, type = "class")
  expect_true(length(preds_class) == nrow(X))
  expect_true(all(preds_class %in% c(1, 2, 3)))
  
  # Probability predictions should return matrix (n_samples x n_classes)
  preds_prob <- predict(model, X, type = "prob")
  expect_true(is.matrix(preds_prob))
  expect_equal(nrow(preds_prob), nrow(X))
  expect_equal(ncol(preds_prob), 3)  # 3 classes
  
  # Probabilities should be between 0 and 1
  expect_true(all(preds_prob >= 0 & preds_prob <= 1))
  
  # Each row should sum to 1
  row_sums <- rowSums(preds_prob)
  expect_equal(row_sums, rep(1, nrow(X)), tolerance = 1e-6)
  
  # Raw predictions
  preds_raw <- predict(model, X, type = "raw")
  expect_true(length(preds_raw) == nrow(X) * 3)  # n_samples * n_classes
})

# Save and load tests using XGBoost/LightGBM style API
# Replicating Python test_save_load.py

test_that("Save and Load Booster works with binary classification (Iris)", {
  X <- as.matrix(iris[, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[, 5])
  y_bin <- ifelse(y == 3, 0, ifelse(y == 2, 1, 0))  # Binary: 0 or 1
  
  model <- perpetual(X, y_bin, objective = "LogLoss")
  preds1 <- predict(model, X, type = "raw")
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, X, type = "raw")
  
  expect_equal(preds1, preds2)
  expect_true(file.exists(tmp))
  
  unlink(tmp)
})

test_that("Save and Load Booster works with multiclass (Iris)", {
  X <- as.matrix(iris[, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[, 5])  # 1, 2, 3
  
  model <- perpetual(X, y, objective = "LogLoss")
  preds1 <- predict(model, X, type = "class")
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, X, type = "class")
  
  expect_equal(preds1, preds2)
  
  unlink(tmp)
})

test_that("Save and load with SquaredLoss preserves predictions (Titanic)", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "SquaredLoss", iteration_limit = 10L)
  preds1 <- predict(model, data$X, type = "raw")
  
  # Save
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  expect_true(file.exists(tmp))
  
  # Load
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, data$X, type = "raw")
  
  expect_equal(preds1, preds2)
  
  # Cleanup
  unlink(tmp)
})

test_that("Save and load with LogLoss preserves predictions (Titanic)", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss", iteration_limit = 10L)
  preds1 <- predict(model, data$X, type = "raw")
  proba1 <- predict(model, data$X, type = "prob")
  
  # Save
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  # Load
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, data$X, type = "raw")
  proba2 <- predict(model2, data$X, type = "prob")
  
  expect_equal(preds1, preds2)
  expect_equal(proba1, proba2)
  
  unlink(tmp)
})

test_that("Saved model JSON is valid", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  # Read and parse JSON
  json_content <- readLines(tmp, warn = FALSE)
  json_str <- paste(json_content, collapse = "\n")
  parsed <- jsonlite::fromJSON(json_str, simplifyVector = FALSE)
  
  expect_true("trees" %in% names(parsed))
  expect_true("base_score" %in% names(parsed))
  
  unlink(tmp)
})

test_that("number_of_trees and base_score preserved after load", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  n_trees1 <- perpetual_n_trees(model)
  base1 <- perpetual_base_score(model)
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  model2 <- perpetual_load(tmp)
  
  expect_equal(n_trees1, perpetual_n_trees(model2))
  expect_equal(base1, perpetual_base_score(model2))
  
  unlink(tmp)
})

# Tests for enhanced R API interface (LightGBM/XGBoost style)

test_that("perpetual_save and perpetual_load work as expected", {
  X <- as.matrix(iris[, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[, 5])
  
  model <- perpetual(X, y, objective = "LogLoss")
  preds1 <- predict(model, X, type = "prob")
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  expect_true(file.exists(tmp))
  
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, X, type = "prob")
  
  expect_equal(preds1, preds2)
  expect_equal(attr(model, "classes"), attr(model2, "classes"))
  
  unlink(tmp)
})

test_that("predict with type = 'contribution' returns valid SHAP values", {
  X <- as.matrix(iris[1:10, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[1:10, 5])
  
  # Binary classification for simplicity
  y_bin <- ifelse(y == 1, 1, 0)
  
  model <- perpetual(X, y_bin, objective = "LogLoss", budget = 1.0)
  
  # Get contributions
  contribs <- predict(model, X, type = "contribution")
  
  expect_true(is.matrix(contribs))
  expect_equal(nrow(contribs), 10)
  expect_equal(ncol(contribs), 5) # 4 features + 1 bias
  expect_true(!any(is.na(contribs)))
})

test_that("predict.PerpetualBooster handles missing classes gracefully", {
  X <- as.matrix(iris[1:10, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[1:10, 5])
  
  model <- perpetual(X, y, objective = "SquaredLoss")
  # Manually strip classes to simulate a model loaded without meta (unlikely now but good to test)
  attr(model, "classes") <- NULL
  
  preds <- predict(model, X, type = "raw")
  expect_true(is.numeric(preds))
  expect_equal(length(preds), 10)
})

test_that("perpetual() training function handles additional parameters", {
  X <- as.matrix(iris[, 1:4])
  storage.mode(X) <- "double"
  y <- as.numeric(iris[, 5])
  
  # Test passing budget and other params - use full dataset to ensure trees are built
  model <- perpetual(X, y, objective = "LogLoss", budget = 1.0, max_bin = 128, log_iterations = 1)
  
  expect_s3_class(model, "PerpetualBooster")
  expect_true(perpetual_n_trees(model) > 0)
})

# Basic booster tests replicating Python test_booster.py
# Uses XGBoost/LightGBM style API: perpetual(), predict()

test_that("Basic fit and predict works with titanic data", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  preds <- predict(model, data$X, type = "raw")
  expect_true(length(preds) == nrow(data$X))
  expect_true(!any(is.na(preds)))
})

test_that("predict with type='prob' returns valid probabilities", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  proba <- predict(model, data$X, type = "prob")
  expect_true(length(proba) == nrow(data$X))
  # Probabilities should be between 0 and 1
  expect_true(all(proba >= 0 & proba <= 1))
})

test_that("predict with type='class' returns labels", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  labels <- predict(model, data$X, type = "class")
  expect_true(length(labels) == nrow(data$X))
  # Labels should be 0 or 1 for binary classification
  expect_true(all(labels %in% c(0, 1)))
})

test_that("Multiple model trains produce consistent results", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model1 <- perpetual(data$X, data$y, objective = "LogLoss", num_threads = 1L)
  preds1 <- predict(model1, data$X, type = "raw")
  
  # Fit again with same params
  model2 <- perpetual(data$X, data$y, objective = "LogLoss", num_threads = 1L)
  preds2 <- predict(model2, data$X, type = "raw")
  
  expect_equal(preds1, preds2, tolerance = 1e-6)
})

test_that("number_of_trees returns positive integer", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  n_trees <- perpetual_n_trees(model)
  expect_true(is.numeric(n_trees))
  expect_true(n_trees > 0)
})

test_that("base_score returns numeric value", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  base <- perpetual_base_score(model)
  expect_true(is.numeric(base))
})

test_that("json_dump returns valid JSON", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  json_str <- perpetual_to_json(model)
  expect_true(nchar(json_str) > 0)
  
  # Should be valid JSON
  parsed <- jsonlite::fromJSON(json_str, simplifyVector = FALSE)
  expect_true(!is.null(parsed))
  expect_true("trees" %in% names(parsed))
})

test_that("SquaredLoss objective works for regression", {
  # Use titanic data with numeric target for regression
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "SquaredLoss")
  
  preds <- predict(model, data$X, type = "raw")
  expect_true(length(preds) == nrow(data$X))
  expect_true(!any(is.na(preds)))
})

test_that("Different booster parameters work", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(
    data$X, data$y,
    objective = "LogLoss",
    budget = 0.3,
    max_bin = 128L,
    num_threads = 1L,
    iteration_limit = 10L
  )
  
  preds <- predict(model, data$X, type = "raw")
  expect_true(length(preds) == nrow(data$X))
})

test_that("print() displays model summary", {
  data <- as_matrix_data(load_titanic_test_data())
  
  model <- perpetual(data$X, data$y, objective = "LogLoss")
  
  # Should not error and print output
  output <- capture.output(print(model))
  expect_true(any(grepl("Perpetual", output)))
})

# Regression tests with cal_housing data using XGBoost/LightGBM style API

test_that("Regression with cal_housing data works", {
  skip_if_no_resources()
  
  data <- load_cal_housing_data()
  X_train <- matrix(data$train$flat_data, nrow = data$train$rows, ncol = data$train$cols, byrow = FALSE)
  X_test <- matrix(data$test$flat_data, nrow = data$test$rows, ncol = data$test$cols, byrow = FALSE)
  storage.mode(X_train) <- "double"
  storage.mode(X_test) <- "double"
  
  model <- perpetual(X_train, data$train$y, objective = "SquaredLoss")
  
  preds <- predict(model, X_test, type = "raw")
  
  expect_true(length(preds) == data$test$rows)
  expect_true(!any(is.na(preds)))
  expect_true(is.numeric(preds))
})

test_that("Regression predictions are reasonable", {
  skip_if_no_resources()
  
  data <- load_cal_housing_data()
  X_train <- matrix(data$train$flat_data, nrow = data$train$rows, ncol = data$train$cols, byrow = FALSE)
  X_test <- matrix(data$test$flat_data, nrow = data$test$rows, ncol = data$test$cols, byrow = FALSE)
  storage.mode(X_train) <- "double"
  storage.mode(X_test) <- "double"
  
  model <- perpetual(X_train, data$train$y, objective = "SquaredLoss")
  
  preds <- predict(model, X_test, type = "raw")
  
  # Predictions should be in a reasonable range (house values are between 0.5 and 5+)
  expect_true(all(preds > 0))
  expect_true(all(preds < 10))  # Median house values in 100k units
  
  # Should have some variance (not all the same prediction)
  expect_true(sd(preds) > 0)
})

test_that("Regression save/load preserves predictions", {
  skip_if_no_resources()
  
  data <- load_cal_housing_data()
  X_train <- matrix(data$train$flat_data, nrow = data$train$rows, ncol = data$train$cols, byrow = FALSE)
  X_test <- matrix(data$test$flat_data, nrow = data$test$rows, ncol = data$test$cols, byrow = FALSE)
  storage.mode(X_train) <- "double"
  storage.mode(X_test) <- "double"
  
  model <- perpetual(X_train, data$train$y, objective = "SquaredLoss", iteration_limit = 20L)
  preds1 <- predict(model, X_test, type = "raw")
  
  tmp <- tempfile(fileext = ".json")
  perpetual_save(model, tmp)
  
  model2 <- perpetual_load(tmp)
  preds2 <- predict(model2, X_test, type = "raw")
  
  expect_equal(preds1, preds2)
  
  unlink(tmp)
})

# Test feature importance and prediction intervals
# These are new features added to the Perpetual R package

test_that("perpetual_importance returns feature importance scores", {
  X <- as.matrix(iris[, 1:4])
  y <- as.numeric(iris[, 5])
  storage.mode(X) <- "double"
  
  model <- perpetual(X, y, objective = "LogLoss", budget = 0.5, seed = 123)
  
  importance <- perpetual_importance(model, method = "gain")
  
  expect_true(length(importance) == 4)
  expect_true(all(importance >= 0))
  expect_true(is.numeric(importance))
})

test_that("perpetual supports seed parameter for reproducibility", {
  X <- as.matrix(iris[, 1:4])
  y <- as.numeric(iris[, 5])
  storage.mode(X) <- "double"
  
  model1 <- perpetual(X, y, objective = "LogLoss", budget = 0.5, seed = 42, num_threads = 1L)
  model2 <- perpetual(X, y, objective = "LogLoss", budget = 0.5, seed = 42, num_threads = 1L)
  
  preds1 <- predict(model1, X, type = "raw")
  preds2 <- predict(model2, X, type = "raw")
  
  expect_equal(preds1, preds2)
})

test_that("perpetual_calibrate and predict intervals work", {
  y_reg <- iris[, 1]
  X_reg <- as.matrix(iris[, 2:4])
  storage.mode(X_reg) <- "double"
  
  model_reg <- perpetual(X_reg, y_reg, objective = "SquaredLoss", budget = 0.5, save_node_stats = TRUE)
  
  # Split for calibration
  set.seed(123)
  idx <- sample(1:nrow(iris), 100)
  X_train <- X_reg[idx, , drop = FALSE]
  y_train <- y_reg[idx]
  X_cal <- X_reg[-idx, , drop = FALSE]
  y_cal <- y_reg[-idx]
  
  perpetual_calibrate(model_reg, X_train, y_train, X_cal, y_cal, alpha = c(0.1))
  
  X_test <- X_reg[1:5, , drop = FALSE]
  intervals <- predict(model_reg, X_test, type = "interval")
  
  expect_true(!is.null(intervals))
  expect_true(length(intervals) > 0)
  expect_true("0.1" %in% names(intervals))
})

# Binary Classification Example with Perpetual
# Using the built-in 'mtcars' dataset to predict automatic vs manual transmission

library(perpetual)

# Prepare data: mtcars has 'am' column (0 = automatic, 1 = manual)
data(mtcars)
X <- as.matrix(mtcars[, c("mpg", "cyl", "disp", "hp", "wt", "qsec")])
y <- mtcars$am

# Split into train/test
set.seed(42)
train_idx <- sample(nrow(X), size = 24)
X_train <- X[train_idx, ]
y_train <- y[train_idx]
X_test <- X[-train_idx, ]
y_test <- y[-train_idx]

# Train a binary classification model
cat("Training binary classification model...\n")
model <- perpetual(
  x = X_train,
  y = y_train,
  objective = "LogLoss",
  budget = 0.5
)

# Print model summary
print(model)

# Predict class labels
pred_class <- predict(model, X_test, type = "class")
cat("\nPredicted classes:", pred_class, "\n")
cat("Actual classes:   ", y_test, "\n")

# Calculate accuracy
accuracy <- mean(pred_class == y_test)
cat("\nAccuracy:", round(accuracy * 100, 1), "%\n")

# Predict probabilities
pred_prob <- predict(model, X_test, type = "prob")
cat("\nPredicted probabilities (P(manual)):\n")
print(round(pred_prob, 3))

# Get raw log-odds scores
pred_raw <- predict(model, X_test, type = "raw")
cat("\nRaw log-odds scores:\n")
print(round(pred_raw, 3))

#!/usr/bin/env Rscript

lib_path <- file.path("package-r", "R_library")
if (!dir.exists(lib_path)) {
  dir.create(lib_path, recursive = TRUE)
}
.libPaths(c(lib_path, .libPaths()))

cat("Installing dependencies to", lib_path, "...\n")
deps <- c("roxygen2", "testthat", "jsonlite")
install.packages(deps, lib = lib_path, repos = "https://cloud.r-project.org")
cat("Installation complete.\n")

#!/bin/bash
set -e

# PGO Optimization Script for PerpetualBooster
# Ensure cargo is in PATH (common issue in some environments)
export PATH="$PATH:$HOME/.cargo/bin:/c/Users/wwwmu/.cargo/bin"

BENCH_NAME="training_benchmark"

echo "Step 1: Checking Tooling..."

# Check for cargo-pgo
if ! cargo pgo --version &> /dev/null; then
    echo "cargo-pgo not found. Installing..."
    # Ensure RUSTFLAGS is unset for the installation to avoid linker issues with proc-macros
    unset RUSTFLAGS
    cargo install cargo-pgo
else
    echo "cargo-pgo is already installed."
fi

# Check for llvm-tools-preview
if ! rustup component list | grep "llvm-tools-preview (installed)" &> /dev/null; then
    echo "llvm-tools-preview not found. Installing..."
    rustup component add llvm-tools-preview
else
    echo "llvm-tools-preview is already installed."
fi

echo "Step 2: Establishing Baseline..."
# Run standard benchmark to save baseline
cargo bench --bench $BENCH_NAME -- --noplot --save-baseline base
# Backup criterion data because cargo clean will wipe it
echo "Backing up baseline data..."
cp -r target/criterion criterion_backup

echo "Step 3: Cleaning Target..."
cargo clean



echo "Step 4: Profiling (Stage 2)..."
# Increase stack size to prevent segfaults during PGO instrumentation on macOS
export RUST_MIN_STACK=8388608
cargo pgo bench -- --bench $BENCH_NAME

echo "Step 5: Optimizing Build (Stage 3)..."
cargo pgo optimize -- --bench $BENCH_NAME

echo "Restoring baseline data..."
# Ensure target/criterion exists
mkdir -p target/criterion
cp -r criterion_backup/* target/criterion/
rm -rf criterion_backup

echo "Step 6: Validation..."
# Find the optimized benchmark binary
# It will be in target/<target-triple>/release/deps/ or target/release/deps/
# We look for the most recent executable matching the benchmark name
# Determine find flag for executables
if find . -maxdepth 0 -executable > /dev/null 2>&1; then
    FIND_EXEC_FLAG="-executable"
else
    FIND_EXEC_FLAG="-perm +111"
fi

BENCH_BIN=$(find target -name "${BENCH_NAME}-*" -type f $FIND_EXEC_FLAG | grep "release/deps" | sort -r | head -n 1)

if [ -z "$BENCH_BIN" ]; then
    # Fallback for Windows if 'executable' check fails or extension is needed
    BENCH_BIN=$(find target -name "${BENCH_NAME}-*.exe" | grep "release/deps" | sort -r | head -n 1)
fi

if [ -f "$BENCH_BIN" ]; then
    echo "Found optimized benchmark binary: $BENCH_BIN"
    echo "Running comparison against baseline..."
    "$BENCH_BIN" --noplot --baseline base
else
    echo "Error: Could not find optimized benchmark binary."
    exit 1
fi

echo "PGO Workflow Completed Successfully!"

Set-Location package-python
python -m black python/perpetual/
python -m black tests/
python -m black examples/
maturin develop --release
pytest tests/test_sklearn.py::test_sklearn_compat_ranking -s
Set-Location ..

Set-Location package-python
uv run python -m ruff check --fix .
uv run python -m ruff format .
uv run maturin develop --release
uv run pytest tests/core/test_tabarena.py::test_tabarena_save_load -s
Set-Location ..

$ErrorActionPreference = "Stop"

# Navigate to project root
$scriptPath = Split-Path -Parent $MyInvocation.MyCommand.Path
$projectRoot = Split-Path -Parent $scriptPath
Set-Location $projectRoot

$RLib = Join-Path $projectRoot "package-r\R_library"
if (-not (Test-Path $RLib)) {
    New-Item -ItemType Directory -Force -Path $RLib
}

$env:R_LIBS_USER = $RLib
$env:R_LIBS_SITE = $RLib

# Try to find Rscript if not in path
if (-not (Get-Command "Rscript" -ErrorAction SilentlyContinue)) {
    Write-Host "Rscript not found in PATH, searching in C:\Program Files\R..." -ForegroundColor Yellow
    $RPath = Get-ChildItem -Path "C:\Program Files\R" -Recurse -Filter "Rscript.exe" -ErrorAction SilentlyContinue | Select-Object -First 1 -ExpandProperty FullName
    if ($RPath) {
        $global:RBinDir = Split-Path -Parent $RPath
        $env:PATH = "$global:RBinDir;$env:PATH"
        Write-Host "Found R at $global:RBinDir, added to PATH." -ForegroundColor Gray
    } else {
        Write-Error "Rscript.exe not found. Please install R and add it to your PATH."
    }
} else {
    $global:RBinDir = Split-Path -Parent (Get-Command "Rscript.exe").Source
}

$RscriptExe = Join-Path $global:RBinDir "Rscript.exe"
$Rexe = Join-Path $global:RBinDir "R.exe"
$env:PERPETUAL_ROOT = $projectRoot.Replace('\', '/')

Write-Host "Setting up R dependencies..." -ForegroundColor Cyan
& $RscriptExe scripts/setup_r_deps.R
Write-Host "Vendoring Rust dependencies and syncing core..." -ForegroundColor Cyan
python scripts/vendor_r.py
if ($LASTEXITCODE -ne 0) {
    Write-Error "Vendor script failed with exit code $LASTEXITCODE"
    exit $LASTEXITCODE
}

# Remove potential stale Cargo.lock in package-r/src/rust to allow fresh resolution matching vendored deps
$RustDir = Join-Path $projectRoot "package-r\src\rust"
$StaleLock = Join-Path $RustDir "Cargo.lock"
if (Test-Path $StaleLock) {
    Write-Host "Removing stale $StaleLock..."
    Remove-Item -Path $StaleLock -Force
}

Write-Host "Building and installing perpetual package..." -ForegroundColor Cyan
$RLibUnix = $RLib.Replace('\', '/')

$LockDir = Join-Path $RLib "00LOCK-perpetual"
if (Test-Path $LockDir) {
    Write-Host "Removing stale lock directory..." -ForegroundColor Yellow
    Remove-Item -Path $LockDir -Recurse -Force
}
$LockDir2 = Join-Path $RLib "00LOCK-package-r"
if (Test-Path $LockDir2) {
    Write-Host "Removing stale lock directory (package-r)..." -ForegroundColor Yellow
    Remove-Item -Path $LockDir2 -Recurse -Force
}

Write-Host "Building and installing perpetual package..." -ForegroundColor Cyan
$RLibUnix = $RLib.Replace('\', '/')

# Run R CMD INSTALL directly to the console
& $Rexe CMD INSTALL package-r --library="$RLibUnix"

if ($LASTEXITCODE -ne 0) {
    Write-Error "R CMD INSTALL failed with exit code $LASTEXITCODE"
    exit $LASTEXITCODE
} else {
    Write-Host "Installation successful." -ForegroundColor Green
}

Write-Host "Running R tests..." -ForegroundColor Cyan
& $RscriptExe -e ".libPaths('$RLibUnix'); library(testthat); library(perpetual); test_dir('package-r/tests/testthat')"

if ($LASTEXITCODE -eq 0) {
    Write-Host "R tests completed successfully!" -ForegroundColor Green
} else {
    Write-Error "R tests failed!"
    exit $LASTEXITCODE
}

#!/bin/bash
set -e

# Navigate to project root
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"
PROJECT_ROOT="$SCRIPT_DIR/.."
cd "$PROJECT_ROOT"

RLIB="$PROJECT_ROOT/package-r/R_library"
mkdir -p "$RLIB"

export R_LIBS_USER="$RLIB"
export R_LIBS_SITE="$RLIB"

echo "Setting up R dependencies..."
Rscript scripts/setup_r_deps.R

echo "Building and installing perpetual package..."
# R CMD INSTALL will trigger Makevars which handles the Rust build
R CMD INSTALL package-r --library="$RLIB"

echo "Running R tests..."
Rscript -e ".libPaths('$RLIB'); library(testthat); library(perpetual); test_dir('package-r/tests/testthat', stop_on_failure=TRUE)"

echo "R tests completed successfully!"

#!/bin/bash
set -e

# Navigate to project root (assuming script is in scripts/)
SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" &> /dev/null && pwd )"
PROJECT_ROOT="$SCRIPT_DIR/.."
cd "$PROJECT_ROOT"

# Setup environment (if cargo is not in path)
if [ -f "$HOME/.cargo/env" ]; then
    source "$HOME/.cargo/env"
fi

# R Library Path
# You can customize this or let R verify it
RLIB="$HOME/R/x86_64-pc-linux-gnu-library/4.3"
mkdir -p "$RLIB"

echo "Building Rust library..."
cd package-r/src/rust
cargo build --release
# Copy the static library to src/ where Makevars expects it
cp target/release/libperpetual_r.a ../
cd ../../..

echo "Installing package with R CMD INSTALL..."
R CMD INSTALL package-r --library="$RLIB"

echo "Running tests..."
Rscript -e ".libPaths('$RLIB'); library(testthat); library(perpetual); test_dir('package-r/tests/testthat')"

echo "Done!"

# CRAN Comments

## Test environments

* local Ubuntu 22.04 install, R 4.5.2
* win-builder (devel and release)

## R CMD check results

There were no ERRORs or WARNINGs.

There is 1 NOTE:

* The package source includes a vendored copy of Rust dependencies in `src/v`. This is necessary for offline compilation on CRAN/R-universe.
 Removing them causes the build to fail. Please ignore this NOTE.

# Perpetual

## Python API Reference

<img alt="PyPI - Version" src="https://img.shields.io/pypi/v/perpetual?link=https%3A%2F%2Fpypi.org%2Fproject%2Fperpetual%2F">

<img alt="Crates.io Version" src="https://img.shields.io/crates/v/perpetual?link=https%3A%2F%2Fcrates.io%2Fcrates%2Fperpetual">

The `PerpetualBooster` class is currently the only public facing class in the package, and can be used to train gradient boosted decision tree ensembles with multiple objective functions.

::: perpetual.PerpetualBooster

## Logging output

Info is logged while the model is being trained if the `log_iterations` parameter is set to a value greater than `0` while fitting the booster. The logs can be printed to stdout while training like so.

```python
import logging
logging.basicConfig()
logging.getLogger().setLevel(logging.INFO)

model = PerpetualBooster(log_iterations=1)
model.fit(X, y)

# INFO:perpetual.perpetualbooster:Completed iteration 0 of 10
# INFO:perpetual.perpetualbooster:Completed iteration 1 of 10
# INFO:perpetual.perpetualbooster:Completed iteration 2 of 10
```

The log output can also be captured in a file also using the `logging.basicConfig()` `filename` option.

```python
import logging
logging.basicConfig(filename="training-info.log")
logging.getLogger().setLevel(logging.INFO)

model = PerpetualBooster(log_iterations=10)
model.fit(X, y)
```

# Benchmark Results: Decisioning Branch vs v0.10.0 Baseline

Date: 2026-01-19

## Configuration

- **Hardware**: Local Machine
- **Benchmark**: `training_benchmark.rs`
- **Samples**: 40
- **Measurement Time**: 60s
- **Cover Types Optimization**: Top 10 features only (indices 0-9)

## Results

### Optimization Loop Results (Current, on top of Opt 4)

| optimization | train_booster_cal_housing | train_booster_cover_types | notes |
| :--- | :--- | :--- | :--- |
| baseline (v0.10.0) | 1.05s | 10.0s | Baseline |
| + Bitset Optimization (Iter 1) | **0.93s** | **0.88s** | Replaced `Option<Box<Vec<bool>>>` with `Option<Box<[u8]>>` (8x smaller, better cache). |
| + Bin Struct Splitting (Iter 2) | 0.99s | 1.57s | [REVERTED] Split `Bin` into `Bin` and `cuts`. `cover_types` regression due to random access. |
| + Obj Fn Vectorization (Iter 3) | 0.80s | 0.79s | `SquaredLoss` loop unrolling (12% faster). `LogLoss` f32 precision (3% faster). No new deps. |
| + Full Vectorization (Iter 4) | **0.88s** | **0.82s** | Extended `f32` loops to all losses. `LogLoss` maintained pure `f32` without wrappers (wrappers caused regression). |

### Historical / Branch Comparisons

| Benchmark | Branch | Result (Time) | confidence interval | Notes |
| :--- | :--- | :--- | :--- | :--- |
| `cal_housing` | `decisioning + opt 4 (bin refactor)` | **1.19s** | `[1.15s - 1.25s]` | **~42% faster** than baseline |
| `cal_housing` | `decisioning + opt 1 (hoist bin sums)` | 1.73s | `[1.69s - 1.78s]` | ~16% faster than baseline |
| `cal_housing` | `decisioning + polars removal, cargo test fixes` | 2.26s | `[2.1828s - 2.3434s]` | Regression from decisioning |
| `cal_housing` | `decisioning` | 1.96s | `[1.8850s - 2.0485s]` | ~5% faster than baseline |
| `cal_housing` | `v0.10.0` | 2.06s | `[2.0157s - 2.1134s]` | Baseline |
| `cover_types` | `decisioning + opt 4 (bin refactor)` | **1.07s** | `[1.04s - 1.10s]` | **~43% faster** than baseline |
| `cover_types` | `decisioning + opt 1 (hoist bin sums)` | 1.54s | `[1.50s - 1.58s]` | ~18% faster than baseline |
| `cover_types` | `decisioning + polars removal, cargo test fixes` | 2.06s | `[1.9588s - 2.1870s]` | Improvement from decisioning |
| `cover_types` | `decisioning` | 2.43s | `[1.9510s - 3.0993s]` | ~29% slower than baseline |
| `cover_types` | `v0.10.0` | 1.88s | `[1.8389s - 1.9254s]` | Baseline |
| `cal_housing` | `decisioning + opt 4 (re-run 2)` | 1.78s | `[1.66s - 1.92s]` | Verification Run 2 (Thin LTO) |
| `cover_types` | `decisioning + opt 4 (re-run 2)` | 1.24s | `[1.19s - 1.30s]` | Verification Run 2 (Thin LTO) |

## Summary

- **Optimization 4 (Bin Struct Refactor)**: Massive performance improvement (~40%+). Refactoring `Bin` to use `u32` for counts and removing `Option` from `h_folded` significantly improved cache locality and reduced memory overhead.
- **Optimization 1 (Hoist Bin Sums)**: Significant performance improvement observed. `cal_housing` reduced to **1.73s** and `cover_types` to **1.54s**.
- **Note on tests**: `test_gbm_sensory` memory limit was adjusted to account for the smaller `Bin` size.

# Contributing to `perpetual`

## Development Setup

The repository comes with a predefined set of development tools in the `Makefile` which can be listed by running `make help` or `make`. Before you start contributing or developing further it is required that you initialize the artifacts and dependencies needed for conducting the unit-tests. To do this run the following command:

```sh
make init
```

For development, it is assumed you have stable Rust installed, and at least Python 3.10.

### Running tests

To run the tests in the repository use `make test` - this will run all tests available in the repository. For Python or Rust specific tests that has no downstream or upstream changes use `make py-test` or `make rust-test`, respectively.

## Benchmarking

Benchmarking is run using the [`criterion`](https://github.com/bheisler/criterion.rs) Rust crate.
To run the benchmarks, you can run the following command from your terminal.

```sh
cargo bench
```

specific benchmarks can be targeted by referring to them by name.

```sh
cargo bench "fast sum"
```

## Pre-commit

The [`pre-commit`](https://pre-commit.com/) framework should be installed and used to ensure all commits meet the required formatting, and linting checks prior to a commit being made to the repository. This is installed by `make init` too.

## Serialization

The saving and loading of the model is all handled by the [`serde`](https://docs.rs/serde/1.0.163/serde/) and [`serde_json`](https://docs.rs/serde_json/latest/serde_json/) crates.

Because of this you will see the following attribue calls sprinkled throughout the package.

```rust
#[derive(Deserialize, Serialize)]
```

Additionally in order to not break backwards compatibility with models saved in previous versions, any new items added to the `Tree` or `PerpetualBooster` struts, should have a default value defined. This way models can be loaded, even if they were saved before the new fields was added.
A default value can be added for a fields using the `#[#[serde(default = "default_sample_method")]]` attribute. Where the string that default is referring to must be the name of a valid function, the following is a complete example of this.

```rust
use crate::sampler::SampleMethod, Sampler;

#[derive(Deserialize, Serialize)]
pub struct PerpetualBooster {
    // ...
    #[serde(default = "default_sample_method")]
    pub sample_method: SampleMethod,
    // ...
}

fn default_sample_method() -> SampleMethod {
    SampleMethod::None
}
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_load}
\alias{perpetual_load}
\title{Load a PerpetualBooster model}
\usage{
perpetual_load(path)
}
\arguments{
\item{path}{String, path to the saved model.}
}
\value{
A \code{PerpetualBooster} object.
}
\description{
Load a PerpetualBooster model
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_calibrate}
\alias{perpetual_calibrate}
\title{Calibrate a PerpetualBooster model}
\usage{
perpetual_calibrate(model, x, y, x_cal, y_cal, alpha)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}

\item{x}{Validation features.}

\item{y}{Validation targets.}

\item{x_cal}{Calibration features.}

\item{y_cal}{Calibration targets.}

\item{alpha}{Calibration parameter.}
}
\description{
Calibrate a PerpetualBooster model
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_base_score}
\alias{perpetual_base_score}
\title{Get the base score of the model}
\usage{
perpetual_base_score(model)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}
}
\value{
Numeric, base score.
}
\description{
Get the base score of the model
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{print.PerpetualBooster}
\alias{print.PerpetualBooster}
\title{Print PerpetualBooster}
\usage{
\method{print}{PerpetualBooster}(x, ...)
}
\arguments{
\item{x}{A \code{PerpetualBooster} object.}

\item{...}{Additional arguments.}
}
\description{
Print PerpetualBooster
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{predict.PerpetualBooster}
\alias{predict.PerpetualBooster}
\title{Predict using a PerpetualBooster model}
\usage{
\method{predict}{PerpetualBooster}(
  object,
  newdata,
  type = c("class", "prob", "raw", "contribution", "interval"),
  method = "average",
  ...
)
}
\arguments{
\item{object}{A \code{PerpetualBooster} object.}

\item{newdata}{A matrix or data.frame of new data to predict on.}

\item{type}{Type of prediction: "class", "prob", "raw", "contribution", or "interval".}

\item{method}{Method for prediction contributions. Default "average".}

\item{...}{Additional arguments.}
}
\value{
A vector or matrix of predictions.
}
\description{
Predict using a PerpetualBooster model
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual}
\alias{perpetual}
\title{Train a PerpetualBooster model}
\usage{
perpetual(
  x,
  y,
  objective = "LogLoss",
  budget = NULL,
  iteration_limit = NULL,
  stopping_rounds = NULL,
  max_bin = NULL,
  num_threads = NULL,
  missing = NULL,
  allow_missing_splits = NULL,
  create_missing_branch = NULL,
  missing_node_treatment = NULL,
  log_iterations = NULL,
  quantile = NULL,
  reset = NULL,
  timeout = NULL,
  memory_limit = NULL,
  seed = NULL,
  ...
)
}
\arguments{
\item{x}{A matrix or data.frame of features.}

\item{y}{A vector of targets (numeric for regression, factor/integer for classification).}

\item{objective}{A string specifying the objective function. Default is "LogLoss".}

\item{budget}{A numeric value ensuring the training time does not exceed this budget (in normalized units).}

\item{iteration_limit}{An integer limit on the number of iterations.}

\item{stopping_rounds}{An integer for early stopping.}

\item{max_bin}{Integer, max number of bins for histograms.}

\item{num_threads}{Integer, number of threads to use.}

\item{missing}{Value to consider as missing data. Default is NaN.}

\item{allow_missing_splits}{Boolean.}

\item{create_missing_branch}{Boolean. Whether to create a separate branch for missing values (ternary trees).}

\item{missing_node_treatment}{String. How to handle weights for missing nodes if create_missing_branch is True. Options: "None", "AssignToParent", "AverageLeafWeight", "AverageNodeWeight".}

\item{log_iterations}{Integer.}

\item{quantile}{Numeric.}

\item{reset}{Boolean.}

\item{timeout}{Numeric.}

\item{memory_limit}{Numeric.}

\item{seed}{Integer seed for reproducibility.}

\item{...}{Additional arguments.}
}
\value{
A \code{PerpetualBooster} object.
}
\description{
Perpetual is a self-generalizing gradient boosting machine that doesn't need 
hyperparameter optimization. It automatically finds the best configuration 
based on the provided budget.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_importance}
\alias{perpetual_importance}
\title{Get feature importance}
\usage{
perpetual_importance(model, method = "gain", normalize = TRUE)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}

\item{method}{String, method for importance (e.g. "gain").}

\item{normalize}{Boolean.}
}
\value{
A named vector of importances.
}
\description{
Get feature importance
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_n_trees}
\alias{perpetual_n_trees}
\title{Get the number of trees in the model}
\usage{
perpetual_n_trees(model)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}
}
\value{
Integer, number of trees.
}
\description{
Get the number of trees in the model
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_to_json}
\alias{perpetual_to_json}
\title{Dump model to JSON string}
\usage{
perpetual_to_json(model)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}
}
\value{
String, JSON representation of the model.
}
\description{
Dump model to JSON string
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api.R
\name{perpetual_save}
\alias{perpetual_save}
\title{Save a PerpetualBooster model}
\usage{
perpetual_save(model, path)
}
\arguments{
\item{model}{A \code{PerpetualBooster} object.}

\item{path}{String, path to save the model.}
}
\description{
Save a PerpetualBooster model
}
